# CairoMakie

The Cairo Backend for Makie

Read the docs for Makie and its backends [here](http://docs.makie.org/stable)


## Issues

Please file all issues in [Makie.jl](https://github.com/MakieOrg/Makie.jl/issues/new), and mention CairoMakie in the issue text.

## Limitations

CairoMakie is intended as a backend for static vector graphics at publication quality. Therefore, it does not support the interactive features of GLMakie and is slower when visualizing large amounts data. 3D plots are available, but may be lacking in visual fidelity due to the inherent limitations of 2D vector graphics.

## Saving

Makie overloads the FileIO interface, so you can save a Scene `scene` as `save("filename.extension", scene)`. CairoMakie supports saving to PNG, PDF, SVG and EPS.

You can scale the size of the output figure, without changing its appearance by passing keyword arguments to `save`. PNGs can be scaled by `px_per_unit` (default 1) and vector graphics (SVG, PDF, EPS) can be scaled by `pt_per_unit`.

```julia
save("plot.svg", scene, pt_per_unit = 0.5) # halve the dimensions of the resulting SVG
save("plot.png", scene, px_per_unit = 2) # double the resolution of the resulting PNG
```

## Using CairoMakie with Gtk.jl

You can render onto a GtkCanvas using Gtk, and use that as a display for your scenes.

```julia
using Gtk, CairoMakie

canvas = @GtkCanvas()
window = GtkWindow(canvas, "Makie", 500, 500)

function drawonto(canvas, figure)
    @guarded draw(canvas) do _
        scene = figure.scene
        resize!(scene, Gtk.width(canvas), Gtk.height(canvas))
        config = CairoMakie.ScreenConfig(1.0, 1.0, :good, true, true)
        screen = CairoMakie.Screen(scene, config, Gtk.cairo_surface(canvas))
        CairoMakie.cairo_draw(screen, scene)
    end
end

fig, ax, pl = heatmap(rand(50, 50)) # or something

drawonto(canvas, fig)
show(canvas); # trigger rendering
```

# @reference_test "Poly fast paths $yscale"
function build_poly_refimg(yscale; kwargs...)
    # We have the following groups funneling into one method each:
    # - Circle, Vector{<:Point2} and Vector{<:Vector{<:Point2}}
    # - Rect2, Vector{Rect2}, BezierPath, Vector{BezierPath}
    # - Polygon, MultiPolygon, Vector{Polygon}, Vector{MultiPolygon}

    function to_bezier(ps)
        path = Any[MoveTo(ps[1])]
        append!(path, [LineTo(ps[i]) for i in 2:length(ps)])
        push!(path, ClosePath())
        return BezierPath(path)
    end

    f = Figure()

    Label(f[1, 1], "outline based", tellwidth = false)
    ax = Axis(f[2, 1], yscale = yscale)
    ps = [(1.0, 1.0), (2.0, 1.0), (1.5, 1.5), (2.0, 2.0), (1.0, 2.0)]
    poly!(ax, ps; kwargs...)
    p = poly!(ax, [ps, [p .+ (2, 0) for p in ps]]; kwargs...)
    translate!(p, 0, 1, 0)
    poly!(ax, Circle(Point2f(3, 1.5), 0.25); kwargs...)

    Label(f[1, 2], "Rect/BezierPath", tellwidth = false)
    ax = Axis(f[2, 2], yscale = yscale)
    poly!(ax, Rect2f(0, 0.5, 1, 1); kwargs...)
    poly!(ax, [Rect2f(0, 2, 1, 1), Rect2f(0, 3, 1, 1)], strokewidth = 1; kwargs...)
    p = poly!(ax, to_bezier(ps); kwargs...)
    translate!(p, 2, 0, 0)
    # Cairo allows this but the recipe doesn't
    # poly!(ax, [to_bezier([p .+ (2, 2) for p in ps]), to_bezier([p .+ (2, 4) for p in ps])])

    Label(f[1, 3], "Polygon", tellwidth = false)
    ax = Axis(f[2, 3], yscale = yscale)
    ps = to_ndim.(Point2f, ps, 0)
    poly!(ax, Polygon(ps); kwargs...)
    polys = [Polygon(ps .+ Ref(Point2f(2, 0))), Polygon(ps .+ Ref(Point2f(3, 0)))]
    poly!(ax, polys; kwargs...)
    p = poly!(ax, MultiPolygon(polys); kwargs...)
    translate!(p, 0, 2, 0)
    p = poly!(ax, [MultiPolygon(polys), MultiPolygon([Polygon(ps)])]; kwargs...)
    translate!(p, 0, 4, 0)

    return f
end

@reference_test "poly fast paths" begin
    build_poly_refimg(identity)
end

@reference_test "poly fast paths with transform_func" begin
    # translate applies after log10, so some plots move more than maybe expected
    build_poly_refimg(log10)
end

@reference_test "poly Float64 rect" begin
    f = Figure()
    ax = Axis(f[1, 1]; limits = (nothing, nothing, 12_000_001, 12_000_004))
    p = poly!(ax, [Rect2d(0, 0, 1, 12_000_002), Rect2d(2, 0, 1, 12_000_003)])
    f
end

@reference_test "poly fast paths - linestyle" begin
    build_poly_refimg(
        identity, linestyle = :dash, strokewidth = 5, strokecolor = :black
    )
end

@reference_test "poly fast paths - line join and cap" begin
    build_poly_refimg(
        identity,
        linecap = :butt, joinstyle = :round,
        strokewidth = 10, strokecolor = :black
    )
end

@reference_test "poly fast paths - miter limits" begin
    build_poly_refimg(
        identity,
        joinstyle = :miter, miter_limit = 2pi / 3,
        strokewidth = 10, strokecolor = :black
    )
end

####################################################################################################
#                                          Infrastructure                                          #
####################################################################################################

########################################
#           Drawing pipeline           #
########################################

# The main entry point into the drawing pipeline
function cairo_draw(screen::Screen, scene::Scene)
    Cairo.save(screen.context)
    draw_background(screen, scene)

    allplots = Makie.collect_atomic_plots(scene; is_atomic_plot = is_cairomakie_atomic_plot)
    sort!(allplots; by = Makie.zvalue2d)
    # If the backend is not a vector surface (i.e., PNG/ARGB),
    # then there is no point in rasterizing twice.
    should_rasterize = is_vector_backend(screen.surface)

    last_scene = scene

    Cairo.save(screen.context)
    for p in allplots
        check_parent_plots(p) do plot
            to_value(get(plot, :visible, true))
        end || continue
        # only prepare for scene when it changes
        # this should reduce the number of unnecessary clipping masks etc.
        pparent = Makie.parent_scene(p)::Scene
        pparent.visible[]::Bool || continue
        if pparent != last_scene
            Cairo.restore(screen.context)
            Cairo.save(screen.context)
            prepare_for_scene(screen, pparent)
            last_scene = pparent
        end
        Cairo.save(screen.context)

        # When a plot is too large to save with a reasonable file size on a vector backend,
        # the user can choose to rasterize it when plotting to vector backends, by using the
        # `rasterize` keyword argument.  This can be set to a Bool or an Int which describes
        # the density of rasterization (in terms of a direct scaling factor.)
        # TODO: In future, this can also be set to a Tuple{Module, Int} which describes
        # the backend module which should be used to render the scene, and the pixel density
        # at which it should be rendered.
        if to_value(get(p, :rasterize, false)) != false && should_rasterize
            draw_plot_as_image(pparent, screen, p, p[:rasterize][])
        else # draw vector
            draw_plot(pparent, screen, p)
        end
        Cairo.restore(screen.context)
    end
    Cairo.restore(screen.context)
    return
end

"""
    is_cairomakie_atomic_plot(plot::Plot)::Bool

Returns whether the plot is considered atomic for the CairoMakie backend.
This is overridden for `Poly`, `Band`, and `Tricontourf` so we can apply
CairoMakie can treat them as atomic plots and render them directly.

Plots with children are by default recursed into.  This can be overridden
by defining specific dispatches for `is_cairomakie_atomic_plot` for a given plot type.
"""
is_cairomakie_atomic_plot(plot::Plot) = Makie.is_atomic_plot(plot) || isempty(plot.plots) || to_value(get(plot, :rasterize, false)) != false

"""
    check_parent_plots(f, plot::Plot)::Bool
Returns whether the plot's parent tree satisfies the predicate `f`.
`f` must return a `Bool` and take a plot as its only argument.
"""
function check_parent_plots(f, plot::Plot)
    if f(plot)
        check_parent_plots(f, parent(plot))
    else
        return false
    end
end

function check_parent_plots(f, scene::Scene)
    return true
end

function prepare_for_scene(screen::Screen, scene::Scene)

    # get the root area to correct for its size when translating
    root_area_height = widths(Makie.root(scene))[2]
    scene_area = viewport(scene)[]
    scene_height = widths(scene_area)[2]
    scene_x_origin, scene_y_origin = scene_area.origin

    # we need to translate x by the origin, so distance from the left
    # but y by the distance from the top, which is not the origin, but can
    # be calculated using the parent's height, the scene's height and the y origin
    # this is because y goes downwards in Cairo and upwards in Makie

    top_offset = root_area_height - scene_height - scene_y_origin
    Cairo.translate(screen.context, scene_x_origin, top_offset)

    # clip the scene to its viewport
    Cairo.rectangle(screen.context, 0, 0, widths(scene_area)...)
    Cairo.clip(screen.context)

    return
end

function draw_background(screen::Screen, scene::Scene)
    w, h = Makie.widths(viewport(Makie.root(scene))[])
    return draw_background(screen, scene, h)
end

function draw_background(screen::Screen, scene::Scene, root_h)
    cr = screen.context
    Cairo.save(cr)
    if scene.clear[]
        bg = scene.backgroundcolor[]
        Cairo.set_source_rgba(cr, red(bg), green(bg), blue(bg), alpha(bg))
        r = viewport(scene)[]
        # Makie has (0,0) at bottom left, Cairo at top left. Makie extends up,
        # Cairo down. Negative height breaks other backgrounds
        x, y = origin(r); w, h = widths(r)
        Cairo.rectangle(cr, x, root_h - y - h, w, h) # background
        fill(cr)
    end
    Cairo.restore(cr)
    return foreach(child_scene -> draw_background(screen, child_scene, root_h), scene.children)
end

function draw_plot(scene::Scene, screen::Screen, primitive::Plot)
    if to_value(get(primitive, :visible, true))
        if is_cairomakie_atomic_plot(primitive)
            Cairo.save(screen.context)
            draw_atomic(scene, screen, primitive)
            Cairo.restore(screen.context)
        end
        if !isempty(primitive.plots)
            zvals = Makie.zvalue2d.(primitive.plots)
            for idx in sortperm(zvals)
                draw_plot(scene, screen, primitive.plots[idx])
            end
        end
    end
    return
end

# Possible improvements for this function:
# - Obtain the bbox of the plot and draw an image which tightly fits that bbox
#   instead of the whole Scene
# - Recognize when a screen is an image surface, and set scale to render the plot
#   at the scale of the device pixel
function draw_plot_as_image(scene::Scene, screen::Screen{RT}, primitive::Plot, scale::Number = 1) where {RT}
    # you can provide `p.rasterize = scale::Int` or `p.rasterize = true`, both of which are numbers

    # Extract scene width in device independent units
    w, h = size(scene)
    # Create a new Screen which renders directly to an image surface,
    # specifically for the plot's parent scene.
    scr = Screen(scene; px_per_unit = scale)
    # Draw the plot to the screen, in the normal way
    draw_plot(scene, scr, primitive)

    # Now, we draw the rasterized plot to the main screen.
    # Since it has already been prepared by `prepare_for_scene`,
    # we can draw directly to the Screen.
    Cairo.rectangle(screen.context, 0, 0, w, h)
    Cairo.save(screen.context)
    Cairo.translate(screen.context, 0, 0)
    # Cairo.scale(screen.context, w / scr.surface.width, h / scr.surface.height)
    Cairo.set_source_surface(screen.context, scr.surface, 0, 0)
    p = Cairo.get_source(scr.context)
    if RT !== SVG
        # this is needed to avoid blurry edges in png renderings, however since Cairo 1.18 this
        # setting seems to create broken SVGs
        Cairo.pattern_set_extend(p, Cairo.EXTEND_PAD)
    end
    # Set filter doesn't work!?
    Cairo.pattern_set_filter(p, Cairo.FILTER_BILINEAR)
    Cairo.fill(screen.context)
    Cairo.restore(screen.context)

    return
end

function draw_atomic(::Scene, ::Screen, x::PlotList)
    return nothing # PlotLists are special, and empty plots
end

function draw_atomic(::Scene, ::Screen, x)
    return @warn "$(typeof(x)) is not supported by cairo right now"
end

ENV["ENABLE_COMPUTE_CHECKS"] = "true"

using Test
using CairoMakie
using Makie.FileIO
using ReferenceTests

# Before changing Pkg environment, try the test in #864
@testset "Runs without error" begin
    fig = Figure()
    scatter(fig[1, 1], rand(10))
    fn = tempname() * ".png"
    try
        save(fn, fig)
    finally
        rm(fn)
    end
end

include(joinpath(@__DIR__, "svg_tests.jl"))
include(joinpath(@__DIR__, "rasterization_tests.jl"))

@testset "changing screens" begin
    @testset "svg -> png" begin
        # Now that scene.current_screens contains a CairoMakie screen after save
        # switching formats is a bit more problematic
        # See comments in src/display.jl + backend_show(screen::Screen, ...)
        f = scatter(1:4)
        save("test.svg", f)
        save("test.png", f)
        save("test.svg", f)
        @test isfile("test.svg")
        @test isfile("test.png")
        rm("test.png")
        rm("test.svg")

    end

    @testset "saving pdf two times" begin
        # https://github.com/MakieOrg/Makie.jl/issues/2433
        fig = Figure(size = (480, 792))
        ax = Axis(fig[1, 1])
        # The IO was shared between screens, which left the second figure empty
        save("fig.pdf", fig, pt_per_unit = 0.5)
        save("fig2.pdf", fig, pt_per_unit = 0.5)
        @test !isempty("fig.pdf")
        @test !isempty("fig2.pdf")
        rm("fig.pdf")
        rm("fig2.pdf")
    end

    @testset "switching from pdf screen to png, colorbuffer" begin
        # https://github.com/MakieOrg/Makie.jl/issues/2438
        # This bug was caused by using the screen size of the pdf screen, which
        # has a different device_scaling_factor, and therefore a different screen size
        fig = scatter(1:4, figure = (; size = (800, 800)))
        save("test.pdf", fig)
        size(Makie.colorbuffer(fig)) == (800, 800)
        rm("test.pdf")
    end

    @testset "switching from pdf screen to png, save" begin
        fig = scatter(1:4, figure = (; size = (800, 800)))
        save("test.pdf", fig)
        save("test.png", fig)
        @test size(load("test.png")) == (1600, 1600)
        rm("test.pdf")
        rm("test.png")
    end

    @testset "removing old screen" begin
        f, ax, pl = scatter(1:4)
        test_type(f, typ) = CairoMakie.get_render_type(Makie.getscreen(f.scene).surface) == typ
        save("test.png", f)
        @test length(f.scene.current_screens) == 1
        @test test_type(f, CairoMakie.IMAGE)

        save("test.svg", f)
        @test length(f.scene.current_screens) == 1
        @test test_type(f, CairoMakie.SVG)

        save("test.png", f)
        @test length(f.scene.current_screens) == 1
        @test test_type(f, CairoMakie.IMAGE)

        rm("test.svg")
        rm("test.png")
    end

    @testset "changing resolution of same format" begin
        # see: https://github.com/MakieOrg/Makie.jl/issues/2433
        # and: https://github.com/MakieOrg/AlgebraOfGraphics.jl/pull/441
        scene = Scene(size = (800, 800))
        load_save(s; kw...) = (save("test.png", s; kw...); load("test.png"))
        @test size(load_save(scene, px_per_unit = 2)) == (1600, 1600)
        @test size(load_save(scene, px_per_unit = 1)) == (800, 800)
        rm("test.png")
    end
end

@testset "mimes" begin
    f, ax, pl = scatter(1:4)
    CairoMakie.activate!(type = "pdf")
    @test showable("application/pdf", f)
    CairoMakie.activate!(type = "eps")
    @test showable("application/postscript", f)
    CairoMakie.activate!(type = "svg")
    @test showable("image/svg+xml", f)
    CairoMakie.activate!(type = "png")
    @test showable("image/png", f)
    # see https://github.com/MakieOrg/Makie.jl/pull/2167
    @test !showable("blaaa", f)

    CairoMakie.activate!(type = "png")
    @test showable("image/png", Scene())
    @test !showable("image/svg+xml", Scene())
    # setting svg should leave png as showable, since it's usually lower in the display stack priority
    CairoMakie.activate!(type = "svg")
    @test showable("image/png", Scene())
    @test showable("image/svg+xml", Scene())
end

@testset "VideoStream & screen options" begin
    N = 3
    points = Observable(Point2f[])
    width = 600
    height = 800
    f, ax, pl = scatter(points, axis = (type = Axis, aspect = DataAspect(), limits = (0.4, N + 0.6, 0.4, N + 0.6)), figure = (size = (width, height),))

    vio = Makie.VideoStream(f; format = "mp4", px_per_unit = 2.0, backend = CairoMakie)
    tmp_path = vio.path

    @test vio.screen isa CairoMakie.Screen{CairoMakie.IMAGE}
    @test size(vio.screen) == size(f.scene) .* 2
    @test vio.screen.device_scaling_factor == 2.0

    Makie.recordframe!(vio)

    html = repr(MIME"text/html"(), vio)
    @test occursin("width=\"$width\"", html)
    @test occursin("height=\"$height\"", html)

    save("test.mp4", vio)
    save("test_2.mkv", vio)
    save("test_3.mp4", vio)
    # make sure all files are correctly saved:
    @test all(isfile, ["test.mp4", "test_2.mkv", "test_3.mp4"])
    @test filesize("test.mp4") == filesize("test_3.mp4") > 3000
    @test filesize("test.mp4") != filesize("test_2.mkv") > 3000
    rm.(["test.mp4", "test_2.mkv", "test_3.mp4"])
    finalize(vio); yield()
    @test !isfile(tmp_path)
end

# @testset "plotlist no ambiguity (#4038)" begin
#     f = plotlist([Makie.SpecApi.Scatter(1:10)])
#     Makie.colorbuffer(f; backend=CairoMakie)
#     plotlist!([Makie.SpecApi.Scatter(1:10)])
# end

@testset "multicolor line clipping (#4313)" begin
    fig, ax, p = contour(rand(20, 20))
    xlims!(ax, 0, 10)
    Makie.colorbuffer(fig; backend = CairoMakie)
end

@testset "ComputeGraph Sanity Checks" begin
    # This is supposed to catch changes in ComputePipeline causing nodes to
    # be skipped or become duplicated. This will also trigger if plot attributes
    # are modified in which case the numbers should just be updated
    f, a, p = scatter(rand(10))
    colorbuffer(f)
    @test length(p.attributes.inputs) == 42
    @test length(p.attributes.outputs) == 87
end

excludes = Set(
    [
        "Line GIF",
        "Streamplot animation",
        "Axis + Surface",
        "Streamplot 3D",
        "Meshscatter Function",
        "Record Video",
        # "mesh textured and loaded", # bad texture resolution on mesh
        "Comparing contours, image, surfaces and heatmaps",
        "Animated surface and wireframe",
        "surface + contour3d",
        "Orthographic Camera", # This renders blank, why?
        "3D Contour with 2D contour slices",
        "Surface with image",
        "FEM poly and mesh", # different color due to bad colormap resolution on mesh
        "Image on Surface Sphere", # bad texture resolution
        "Arrows 3D",
        "Connected Sphere",
        # markers too big, close otherwise, needs to be assimilated with glmakie
        "Depth Shift",
        "Order Independent Transparency",
        "scatter with glow", # some are missing
        "Textured meshscatter", # not yet implemented
        "Voxel - texture mapping", # textures not implemented
        "Voxel uvs", # textures not implemented
        "picking", # Not implemented
        "MetaMesh (Sponza)", # makes little sense without per pixel depth order
        "Mesh with 3d volume texture", # Not implemented yet
        "Volume absorption",
        "DataInspector", "DataInspector 2", # No DataInspector without pick/interactivity
    ]
)

functions = [:volume, :volume!, :uv_mesh]

@testset "refimages" begin
    CairoMakie.activate!(type = "png", px_per_unit = 1)
    ReferenceTests.mark_broken_tests(excludes, functions = functions)
    recorded_files, recording_dir = @include_reference_tests CairoMakie "refimages.jl" joinpath(@__DIR__, "cairo_refimages.jl")
    missing_images, scores = ReferenceTests.record_comparison(recording_dir, "CairoMakie")
    ReferenceTests.test_comparison(scores; threshold = 0.05)
end

@testset "PdfVersion" begin
    @test CairoMakie.pdfversion("1.4") === CairoMakie.PDFv14
    @test CairoMakie.pdfversion("1.5") === CairoMakie.PDFv15
    @test CairoMakie.pdfversion("1.6") === CairoMakie.PDFv16
    @test CairoMakie.pdfversion("1.7") === CairoMakie.PDFv17
    @test_throws ArgumentError CairoMakie.pdfversion("foo")
end

@testset "restrict PDF version" begin
    magic_number(filename) = open(filename) do f
        return String(read(f, sizeof("%PDF-X.Y")))
    end

    filename = "$(tempname()).pdf"

    try
        save(filename, Figure(), pdf_version = nothing)
        @test startswith(magic_number(filename), "%PDF-")
    finally
        rm(filename)
    end

    for version in ["1.4", "1.5", "1.6", "1.7"]
        try
            save(filename, Figure(), pdf_version = version)
            @test magic_number(filename) == "%PDF-$version"
        finally
            rm(filename)
        end
    end

    @test_throws ArgumentError save(filename, Figure(), pdf_version = "foo")
end

@testset "Tick Events" begin
    f, a, p = scatter(rand(10))
    @test events(f).tick[] == Makie.Tick()

    filename = "$(tempname()).png"
    try
        save(filename, f)
        tick = events(f).tick[]
        @test tick.state == Makie.OneTimeRenderTick
        @test tick.count == 0
        @test tick.time == 0.0
        @test tick.delta_time == 0.0
    finally
        rm(filename)
    end

    filename = "$(tempname()).mp4"
    try
        tick_record = Makie.Tick[]
        record(_ -> push!(tick_record, events(f).tick[]), f, filename, 1:10, framerate = 30)
        dt = 1.0 / 30.0

        for (i, tick) in enumerate(tick_record)
            @test tick.state == Makie.OneTimeRenderTick
            @test tick.count == i - 1
            @test tick.time ≈ dt * (i - 1)
            @test tick.delta_time ≈ dt
        end
    finally
        rm(filename)
    end

    # test destruction of tick overwrite
    f, a, p = scatter(rand(10))
    let
        io = VideoStream(f)
        @test events(f).tick[] == Makie.Tick(Makie.OneTimeRenderTick, 0, 0.0, 1.0 / io.options.framerate)
        nothing
    end
    tick = Makie.Tick(Makie.UnknownTickState, 1, 1.0, 1.0)
    events(f).tick[] = tick
    @test events(f).tick[] == tick
end

@testset "line projection" begin
    # Check #4627
    f = Figure(size = (600, 450))
    a, p = stephist(f[1, 1], 1:10, bins = [0, 5, 10], axis = (; limits = (0 .. 10, nothing)))
    Makie.update_state_before_display!(f)
    colorbuffer(f) # trigger add_computations! for CairoMakie
    lp = p.plots[1].plots[1]
    ps = lp.clipped_points[]
    # Points 1, 2, 5, 6 are on the clipping boundary, 7 is a duplicate of 6.
    # The output may drop 1, 6, 7 and adjust 2, 5 if these points are recognized
    # as outside. The adjustment of 2, 5 should be negligible.
    necessary_points = Vec{2, Float32}[[0.0, 89.77272], [275.5, 89.77272], [275.5, 17.95454], [551.0, 17.95454]]
    @test length(ps) >= 4
    @test all(ref -> findfirst(p -> isapprox(p, ref, atol = 1.0e-4), ps) !== nothing, necessary_points)

    ls_points = lp.positions[][[1, 2, 2, 3, 3, 4, 4, 5, 5, 6]]
    ls = linesegments!(a, ls_points, xautolimits = false, yautolimits = false)
    colorbuffer(f)
    ps = ls.clipped_points[]
    @test length(ps) >= 6 # at least 6 points: [2,3,3,4,4,5]
    @test all(ref -> findfirst(p -> isapprox(p, ref, atol = 1.0e-4), ps) !== nothing, necessary_points)

    # Check that `reinterpret`ed arrays of points are handled correctly
    # ref. https://github.com/MakieOrg/Makie.jl/issues/4661

    data = reinterpret(Point2f, rand(Point2f, 10) .=> rand(Point2f, 10))

    f, a, p = lines(data)
    Makie.update_state_before_display!(f)
    colorbuffer(f)
    ps = @test_nowarn p.clipped_points[]
    @test length(ps) == length(data) # this should never clip!
end

@testset "issue 4970 (invalid io use during finalization)" begin
    @testset "$mime" for mime in CairoMakie.SUPPORTED_MIMES
        @test_nowarn begin
            sprint(io -> show(io, mime, Scene()))
            GC.gc()
        end
    end
end

#=
Image:
- positions_transformed_f32c are rect vertices
Heatmap:
- nope
- heatmap transform adds x_transformed_f32c, y_transformed_f32c
=#

function image_grid!(::typeof(heatmap), attr)
    Makie.add_computation!(attr, nothing, Val(:heatmap_transform))
    return register_computation!(attr, [:x_transformed_f32c, :y_transformed_f32c], [:grid_x, :grid_y]) do (x, y), _, _
        xs = regularly_spaced_array_to_range(x)
        ys = regularly_spaced_array_to_range(y)
        return (xs, ys)
    end
end

function image_grid!(::typeof(image), attr)
    # Rect vertices
    return register_computation!(attr, [:positions_transformed_f32c, :image], [:grid_x, :grid_y]) do (positions, image), _, _
        (x0, y0), _, (x1, y1), _ = positions
        xs = range(x0, x1, length = size(image, 1) + 1)
        ys = range(y0, y1, length = size(image, 2) + 1)
        return (xs, ys)
    end
end


# Note: Changed very little here
function draw_atomic(scene::Scene, screen::Screen{RT}, plot::Union{Heatmap, Image}) where {RT}
    attr = plot.attributes
    image_grid!(Makie.plotfunc(plot), attr)
    add_constant!(attr, :is_image, plot isa Image)
    if plot isa Heatmap && !haskey(attr, :uv_transform)
        add_constant!(attr, :uv_transform, nothing)
    end
    imagelike_uv_transform!(attr)
    Makie.compute_colors!(attr)
    inputs = [
        :grid_x, :grid_y, :image,
        :interpolate, :space, :projectionview, :model_f32c,
        :clip_planes, :cairo_uv_transform, :resolution, :computed_color,
    ]
    extract_attributes!(attr, inputs, :cairo_attributes)
    ctx = screen.context
    not_svg = RT !== SVG
    return draw_image(ctx, not_svg, attr[:cairo_attributes][])
end

function imagelike_uv_transform!(attr)

    return map!(attr, [:uv_transform, :image, :is_image], :cairo_uv_transform) do T, image, is_image
        if is_image
            # Cairo uses pixel units so we need to transform those to a 0..1 range,
            # then apply uv_transform, then scale them back to pixel units.
            # Cairo also doesn't have the yflip we have in OpenGL, so we need to
            # invert y.
            T3 = Mat3f(T[1], T[2], 0, T[3], T[4], 0, T[5], T[6], 1)
            T3 = Makie.uv_transform(Vec2f(size(image))) * T3 *
                Makie.uv_transform(Vec2f(0, 1), 1.0f0 ./ Vec2f(size(image, 1), -size(image, 2)))
            return T3[Vec(1, 2), Vec(1, 2, 3)]
        else
            return Mat{2, 3, Float32}(1, 0, 0, 1, 0, 0)
        end
    end
end

function draw_image(ctx, not_svg, attr)
    model = attr.model_f32c
    xs = attr.grid_x
    ys = attr.grid_y
    projectionview = attr.projectionview
    resolution = attr.resolution
    interpolate = attr.interpolate
    uv_transform = attr.cairo_uv_transform
    clip_planes = attr.clip_planes
    color_image = attr.computed_color
    space = attr.space

    # Vector backends don't support FILTER_NEAREST for interp == false, so in that case we also need to draw rects
    is_vector = is_vector_backend(ctx)
    # transform_func is already included in xs, ys, so we can see its effect in is_regular_grid
    is_identity_transform = Makie.is_translation_scale_matrix(model)
    is_regular_grid = xs isa AbstractRange && ys isa AbstractRange
    is_xy_aligned = Makie.is_translation_scale_matrix(projectionview)

    if interpolate
        if !is_regular_grid
            error("$(typeof(xs)) with interpolate = true with a non-regular grid is not supported right now.")
        end
        if !is_identity_transform
            error("$(typeof(xs)) with interpolate = true with a non-identity transform is not supported right now.")
        end
    end

    # find projected image corners
    # this already takes care of flipping the image to correct cairo orientation

    xy = cairo_project_to_screen_impl(projectionview, resolution, model, Point2(first(xs), first(ys)))
    xymax = cairo_project_to_screen_impl(projectionview, resolution, model, Point2(last(xs), last(ys)))

    w, h = xymax .- xy

    can_use_fast_path = !(is_vector && !interpolate) && is_regular_grid && is_identity_transform &&
        (interpolate || is_xy_aligned) && isempty(clip_planes)


    return if can_use_fast_path
        s = to_cairo_image(color_image)

        weird_cairo_limit = (2^15) - 23
        if s.width > weird_cairo_limit || s.height > weird_cairo_limit
            error("Cairo stops rendering images bigger than $(weird_cairo_limit), which is likely a bug in Cairo. Please resample your image/heatmap with heatmap(Resampler(data)).")
        end
        Cairo.rectangle(ctx, xy..., w, h)
        Cairo.save(ctx)
        Cairo.translate(ctx, xy...)
        Cairo.scale(ctx, w / s.width, h / s.height)
        Cairo.set_source_surface(ctx, s, 0, 0)
        p = Cairo.get_source(ctx)
        if not_svg
            # this is needed to avoid blurry edges in png renderings, however since Cairo 1.18 this
            # setting seems to create broken SVGs
            Cairo.pattern_set_extend(p, Cairo.EXTEND_PAD)
        end
        filt = interpolate ? Cairo.FILTER_BILINEAR : Cairo.FILTER_NEAREST
        Cairo.pattern_set_filter(p, filt)
        pattern_set_matrix(p, Cairo.CairoMatrix(uv_transform...))
        Cairo.fill(ctx)
        Cairo.restore(ctx)
        pattern_set_matrix(p, Cairo.CairoMatrix(1, 0, 0, 1, 0, 0))
        Cairo.pattern_set_extend(p, Cairo.EXTEND_NONE)  # Reset pattern extend mode
        Cairo.pattern_set_filter(p, Cairo.FILTER_FAST)  # Reset to default filter
    else
        # find projected image corners
        # this already takes care of flipping the image to correct cairo orientation
        xys = let
            transformed = [Point2f(x, y) for x in xs, y in ys]

            # This should transform to the coordinate system transformed is in,
            # which is pre model_f32c application, not pre model application
            planes = if Makie.is_data_space(space)
                to_model_space(model, clip_planes)
            else
                Plane3f[]
            end

            for i in eachindex(transformed)
                if is_clipped(planes, transformed[i])
                    transformed[i] = Point2f(NaN)
                end
            end

            cairo_project_to_screen_impl(projectionview, resolution, model, transformed)
        end

        # Note: xs and ys should have size ni+1, nj+1
        ni, nj = size(color_image)
        if ni + 1 != length(xs) || nj + 1 != length(ys)
            error("Error in conversion pipeline. xs and ys should have size ni+1, nj+1. Found: xs: $(length(xs)), ys: $(length(ys)), ni: $(ni), nj: $(nj)")
        end
        _draw_rect_heatmap(ctx, xys, ni, nj, color_image)
    end
end


"""
    regularly_spaced_array_to_range(arr)
If possible, converts `arr` to a range.
If not, returns array unchanged.
"""
function regularly_spaced_array_to_range(arr)
    diffs = unique!(sort!(diff(arr)))
    step = sum(diffs) ./ length(diffs)
    if all(x -> x ≈ step, diffs)
        m, M = extrema(arr)
        if step < zero(step)
            m, M = M, m
        end
        # don't use stop=M, since that may not include M
        return range(m; step = step, length = length(arr))
    else
        return arr
    end
end

regularly_spaced_array_to_range(arr::AbstractRange) = arr

function _draw_rect_heatmap(ctx, xys, ni, nj, colors)
    return @inbounds for i in 1:ni, j in 1:nj
        p1 = xys[i, j]
        p2 = xys[i + 1, j]
        p3 = xys[i + 1, j + 1]
        p4 = xys[i, j + 1]
        if isnan(p1) || isnan(p2) || isnan(p3) || isnan(p4)
            continue
        end

        # Rectangles and polygons that are directly adjacent usually show
        # white lines between them due to anti aliasing. To avoid this we
        # increase their size slightly.

        if alpha(colors[i, j]) == 1
            # To avoid gaps between heatmap cells we pad cells.
            # For 3D compatibility (and rotation, inversion/mirror) we pad cells
            # using directional vectors, not along x/y directions.
            v1 = normalize(p2 - p1)
            v2 = normalize(p4 - p1)
            # To avoid shifting cells we only pad them on the +i, +j side, which
            # gets covered by later cells.
            # To avoid enlarging the final column and row of the heatmap, the
            # last set of cells is not padded. (i != ni), (j != nj)
            p2 += Float32(i != ni) * v1
            p3 += Float32(i != ni) * v1 + Float32(j != nj) * v2
            p4 += Float32(j != nj) * v2
        end

        Cairo.set_line_width(ctx, 0)
        Cairo.move_to(ctx, p1[1], p1[2])
        Cairo.line_to(ctx, p2[1], p2[2])
        Cairo.line_to(ctx, p3[1], p3[2])
        Cairo.line_to(ctx, p4[1], p4[2])
        Cairo.close_path(ctx)
        Cairo.set_source_rgba(ctx, rgbatuple(colors[i, j])...)
        Cairo.fill(ctx)
    end
end

function draw_atomic(::Scene, screen::Screen, plot::PT) where {PT <: Union{Lines, LineSegments}}
    ctx = screen.context
    attr = plot.attributes
    add_constant!(attr, :is_lines_plot, plot isa Lines)
    if plot isa LineSegments
        add_constant!(attr, :joinstyle, nothing)
        add_constant!(attr, :miter_limit, nothing)
    end

    Makie.compute_colors!(attr)
    add_projected_line_points!(attr)
    extract_attributes!(
        plot.attributes, [
            :clipped_points, :clipped_linewidths, :clipped_colors,
            :linestyle, :linecap, :joinstyle, :miter_limit, :is_lines_plot,
        ], :cairo_attributes
    )
    draw_lineplot(ctx, attr.cairo_attributes[])
    return
end

function draw_lineplot(ctx, attributes)
    positions = attributes.clipped_points
    isempty(positions) && return

    linewidth = attributes.clipped_linewidths
    color = attributes.clipped_colors
    linestyle = attributes.linestyle
    miter_limit = attributes.miter_limit
    is_lines_plot = attributes.is_lines_plot
    linecap = attributes.linecap

    # The linestyle can be set globally, as we do here.
    pattern = to_cairo_linestyle(linestyle, linewidth)
    if !isnothing(pattern)
        Cairo.set_dash(ctx, pattern)
    end

    # linecap
    Cairo.set_line_cap(ctx, to_cairo_linecap(linecap))

    miter_angle = is_lines_plot ? miter_limit : 2pi / 3
    set_miter_limit(ctx, to_cairo_miter_limit(miter_angle))
    joinstyle = is_lines_plot ? attributes.joinstyle : 0
    Cairo.set_line_join(ctx, to_cairo_joinstyle(joinstyle))

    # TODO, how do we allow this conversion?s
    # if is_lines_plot && to_value(plot.attributes) isa BezierPath
    #     return draw_bezierpath_lines(ctx, to_value(plot.attributes), plot, color, space, model, linewidth)
    # end
    if color isa AbstractArray || linewidth isa AbstractArray
        # stroke each segment separately, this means disjointed segments with probably
        # wonky dash patterns if segments are short
        draw_multi(
            is_lines_plot, ctx,
            positions,
            color, linewidth,
            isnothing(linestyle) ? nothing : diff(Float64.(linestyle))
        )
    else
        # stroke the whole line at once if it has only one color
        # this allows correct linestyles and line joins as well and will be the
        # most common case
        Cairo.set_line_width(ctx, linewidth)
        Cairo.set_source_rgba(ctx, red(color), green(color), blue(color), alpha(color))
        draw_single(is_lines_plot, ctx, positions)
    end
    return
end


function add_projected_line_points!(attr)
    inputs = [:positions_transformed_f32c, :model_f32c, :projectionview]
    map!(attr, inputs, :clipspace_points) do points, model_f32c, projectionview
        transform = projectionview * model_f32c
        return map(points) do point
            return transform * to_ndim(Vec4d, to_ndim(Vec3d, point, 0), 1)
        end
    end
    Makie.add_computation!(attr, Val(:uniform_clip_planes), :clip)
    inputs = [:clipspace_points, :computed_color, :linewidth, :is_lines_plot, :uniform_clip_planes, :resolution]
    outputs = [:clipped_points, :clipped_colors, :clipped_linewidths]
    return register_computation!(attr, inputs, outputs) do (clip_points, colors, linewidths, is_lines_plot, clip_planes, res), _, _
        return clip_line_points(clip_points, colors, linewidths, is_lines_plot, clip_planes, res)
    end
end

function clip_line_points(clip_points, colors, linewidths, is_lines_plot, clip_planesv4f, res)
    # If colors are defined per point they need to be interpolated like positions
    # at clip planes
    per_point_colors = colors isa AbstractArray
    per_point_linewidths = is_lines_plot && (linewidths isa AbstractArray)

    clip_planes = map(clip_planesv4f) do plane
        # TODO, just not unwrap planes immediately in backend-functinality?
        return Plane3f(plane[Vec(1, 2, 3)], plane[4])
    end

    # Fix lines with points far outside the clipped region not drawing at all
    # TODO this can probably be done more efficiently by checking -1 ≤ x, y ≤ 1
    #      directly and calculating intersections directly (1D)
    push!(
        clip_planes,
        Plane3f(Vec3f(-1, 0, 0), -1.0f0), Plane3f(Vec3f(+1, 0, 0), -1.0f0),
        Plane3f(Vec3f(0, -1, 0), -1.0f0), Plane3f(Vec3f(0, +1, 0), -1.0f0)
    )

    # outputs
    screen_points = sizehint!(Vec2f[], length(clip_points))
    color_output = sizehint!(eltype(colors)[], length(clip_points))
    linewidth_output = sizehint!(eltype(linewidths)[], length(clip_points))

    # Handling one segment per iteration
    if is_lines_plot
        clip_lines!(
            clip_points, colors, linewidths, clip_planes, res, per_point_colors, per_point_linewidths,
            screen_points, color_output, linewidth_output
        )
    else
        clip_linesegments!(
            clip_points, colors, clip_planes, res, per_point_colors,
            screen_points, color_output
        )
    end
    return screen_points, ifelse(per_point_colors, color_output, colors),
        ifelse(per_point_linewidths, linewidth_output, linewidths)
end


function clip_linesegments!(
        clip_points, colors, clip_planes, res, per_point_colors,
        screen_points, color_output
    )

    for i in 1:2:(length(clip_points) - 1)
        if per_point_colors
            c1 = colors[i]
            c2 = colors[i + 1]
        end

        p1 = clip_points[i]
        p2 = clip_points[i + 1]
        v = p2 - p1

        # Handle near/far clipping
        if p1[4] <= 0.0
            p1 = p1 + (-p1[4] - p1[3]) / (v[3] + v[4]) * v
            if per_point_colors
                c1 = c1 + (-p1[4] - p1[3]) / (v[3] + v[4]) * (c2 - c1)
            end
        end
        if p2[4] <= 0.0
            p2 = p2 + (-p2[4] - p2[3]) / (v[3] + v[4]) * v
            if per_point_colors
                c2 = c2 + (-p2[4] - p2[3]) / (v[3] + v[4]) * (c2 - c1)
            end
        end

        for plane in clip_planes
            d1 = dot(plane.normal, Vec3f(p1)) - plane.distance * p1[4]
            d2 = dot(plane.normal, Vec3f(p2)) - plane.distance * p2[4]

            if (d1 < 0.0) && (d2 < 0.0)
                # start and end clipped by one plane -> not visible
                # to keep index order we just set p1 and p2 to NaN and insert anyway
                p1 = Vec4f(NaN)
                p2 = Vec4f(NaN)
                break
            elseif (d1 < 0.0)
                # p1 clipped, move it towards p2 until unclipped
                p1 = p1 - d1 * (p2 - p1) / (d2 - d1)
                if per_point_colors
                    c1 = c1 - d1 * (c2 - c1) / (d2 - d1)
                end
            elseif (d2 < 0.0)
                # p2 clipped, move it towards p1 until unclipped
                p2 = p2 - d2 * (p1 - p2) / (d1 - d2)
                if per_point_colors
                    c2 = c2 - d2 * (c1 - c2) / (d1 - d2)
                end
            end
        end

        # no need to disconnected segments, just insert adjusted points
        push!(screen_points, clip2screen(p1, res), clip2screen(p2, res))
        if per_point_colors
            push!(color_output, c1, c2)
        end
    end
    return
end

function clip_lines!(
        clip_points, colors, linewidths, clip_planes, res, per_point_colors, per_point_linewidths,
        screen_points, color_output, linewidth_output
    )
    last_is_nan = true
    for i in 1:(length(clip_points) - 1)
        hidden = false
        disconnect1 = false
        disconnect2 = false

        if per_point_colors
            c1 = colors[i]
            c2 = colors[i + 1]
        end

        p1 = clip_points[i]
        p2 = clip_points[i + 1]
        v = p2 - p1

        # Handle near/far clipping
        if p1[4] <= 0.0
            disconnect1 = true
            p1 = p1 + (-p1[4] - p1[3]) / (v[3] + v[4]) * v
            if per_point_colors
                c1 = c1 + (-p1[4] - p1[3]) / (v[3] + v[4]) * (c2 - c1)
            end
        end
        if p2[4] <= 0.0
            disconnect2 = true
            p2 = p2 + (-p2[4] - p2[3]) / (v[3] + v[4]) * v
            if per_point_colors
                c2 = c2 + (-p2[4] - p2[3]) / (v[3] + v[4]) * (c2 - c1)
            end
        end

        for plane in clip_planes
            d1 = dot(plane.normal, Vec3f(p1)) - plane.distance * p1[4]
            d2 = dot(plane.normal, Vec3f(p2)) - plane.distance * p2[4]

            if (d1 < 0.0) && (d2 < 0.0)
                # start and end clipped by one plane -> not visible
                hidden = true
                break
            elseif (d1 < 0.0)
                # p1 clipped, move it towards p2 until unclipped
                disconnect1 = true
                p1 = p1 - d1 * (p2 - p1) / (d2 - d1)
                if per_point_colors
                    c1 = c1 - d1 * (c2 - c1) / (d2 - d1)
                end
            elseif (d2 < 0.0)
                # p2 clipped, move it towards p1 until unclipped
                disconnect2 = true
                p2 = p2 - d2 * (p1 - p2) / (d1 - d2)
                if per_point_colors
                    c2 = c2 - d2 * (c1 - c2) / (d1 - d2)
                end
            end
        end

        if hidden && !last_is_nan
            # if segment hidden make sure the line separates
            last_is_nan = true
            push!(screen_points, Vec2f(NaN))
            if per_point_linewidths
                push!(linewidth_output, linewidths[i])
            end
            if per_point_colors
                push!(color_output, c1)
            end
        elseif !hidden
            # if not hidden, always push the first element to 1:end-1 line points

            # if the start of the segment is disconnected (moved), make sure the
            # line separates before it
            if disconnect1 && !last_is_nan
                push!(screen_points, Vec2f(NaN))
                if per_point_linewidths
                    push!(linewidth_output, linewidths[i])
                end
                if per_point_colors
                    push!(color_output, c1)
                end
            end

            last_is_nan = false
            push!(screen_points, clip2screen(p1, res))
            if per_point_linewidths
                push!(linewidth_output, linewidths[i])
            end
            if per_point_colors
                push!(color_output, c1)
            end

            # if the end of the segment is disconnected (moved), add the adjusted
            # point and separate it from from the next segment
            if disconnect2
                last_is_nan = true
                push!(screen_points, clip2screen(p2, res), Vec2f(NaN))
                if per_point_linewidths
                    push!(linewidth_output, linewidths[i + 1], linewidths[i + 1])
                end
                if per_point_colors
                    push!(color_output, c2, c2) # relevant, irrelevant
                end
            end
        end
    end

    # If last_is_nan == true, the last segment is either hidden or the moved
    # end point has been added. If it is false we're missing the last regular
    # clip_points
    return if !last_is_nan
        push!(screen_points, clip2screen(clip_points[end], res))
        if per_point_linewidths
            push!(linewidth_output, linewidths[end])
        end
        if per_point_colors
            push!(color_output, colors[end])
        end
    end
end


function draw_multi(islines, ctx, positions, colors, linewidths, dash)
    if islines
        return draw_multi_lines(ctx, positions, colors, linewidths, dash)
    else
        return draw_multi_segments(ctx, positions, colors, linewidths, dash)
    end
end

function draw_multi_segments(ctx, positions, colors, linewidths, dash)
    @assert iseven(length(positions))

    for i in 1:2:length(positions)
        if isnan(positions[i + 1]) || isnan(positions[i])
            continue
        end
        lw = sv_getindex(linewidths, i)
        if lw != sv_getindex(linewidths, i + 1)
            error("Cairo doesn't support two different line widths ($lw and $(sv_getindex(linewidths, i + 1)) at the endpoints of a line.")
        end
        Cairo.move_to(ctx, positions[i]...)
        Cairo.line_to(ctx, positions[i + 1]...)
        Cairo.set_line_width(ctx, lw)

        !isnothing(dash) && Cairo.set_dash(ctx, dash .* lw)
        c1 = sv_getindex(colors, i)
        c2 = sv_getindex(colors, i + 1)
        # we can avoid the more expensive gradient if the colors are the same
        # this happens if one color was given for each segment
        if c1 == c2
            Cairo.set_source_rgba(ctx, red(c1), green(c1), blue(c1), alpha(c1))
            Cairo.stroke(ctx)
        else
            pat = Cairo.pattern_create_linear(positions[i]..., positions[i + 1]...)
            Cairo.pattern_add_color_stop_rgba(pat, 0, red(c1), green(c1), blue(c1), alpha(c1))
            Cairo.pattern_add_color_stop_rgba(pat, 1, red(c2), green(c2), blue(c2), alpha(c2))
            Cairo.set_source(ctx, pat)
            Cairo.stroke(ctx)
            Cairo.destroy(pat)
        end
    end
    return
end


function draw_multi_lines(ctx, positions, colors, linewidths, dash)
    isempty(positions) && return

    @assert !(colors isa AbstractVector) || length(colors) == length(positions) "Found: $(length(positions)) positions, $(typeof(colors)) colors"
    @assert !(linewidths isa AbstractVector) || length(linewidths) == length(positions) "Found: $(length(positions)) positions, $(typeof(linewidths)) linewidths"

    prev_color = sv_getindex(colors, 1)
    prev_linewidth = sv_getindex(linewidths, 1)
    prev_position = positions[begin]
    prev_nan = isnan(prev_position)
    prev_continued = false
    start = positions[begin]

    if !prev_nan
        # first is not nan, move_to
        Cairo.move_to(ctx, positions[begin]...)
    else
        # first is nan, do nothing
    end

    for i in eachindex(positions)[(begin + 1):end]
        this_position = positions[i]
        this_color = sv_getindex(colors, i)
        this_nan = isnan(this_position)
        this_linewidth = sv_getindex(linewidths, i)
        if this_nan
            # this is nan
            if prev_continued
                # and this is prev_continued, so set source and stroke to finish previous line
                (prev_position ≈ start) && Cairo.close_path(ctx)
                Cairo.set_line_width(ctx, this_linewidth)
                !isnothing(dash) && Cairo.set_dash(ctx, dash .* this_linewidth)
                Cairo.set_source_rgba(ctx, red(prev_color), green(prev_color), blue(prev_color), alpha(prev_color))
                Cairo.stroke(ctx)
            else
                # but this is not prev_continued, so do nothing
            end
        end
        if prev_nan
            # previous was nan
            if !this_nan
                # but this is not nan, so move to this position
                Cairo.move_to(ctx, this_position...)
                start = this_position
            else
                # and this is also nan, do nothing
            end
        else
            if this_color == prev_color
                # this color is like the previous
                if !this_nan
                    # and this is not nan, so line_to and set prev_continued
                    this_linewidth != prev_linewidth && error("Encountered two different linewidth values $prev_linewidth and $this_linewidth in `lines` at index $(i - 1). Different linewidths in one line are only permitted in CairoMakie when separated by a NaN point.")
                    Cairo.line_to(ctx, this_position...)
                    prev_continued = true

                    if i == lastindex(positions)
                        # this is the last element so stroke this
                        (this_position ≈ start) && Cairo.close_path(ctx)
                        Cairo.set_line_width(ctx, this_linewidth)
                        !isnothing(dash) && Cairo.set_dash(ctx, dash .* this_linewidth)
                        Cairo.set_source_rgba(ctx, red(this_color), green(this_color), blue(this_color), alpha(this_color))
                        Cairo.stroke(ctx)
                    end
                else
                    # but this is nan, so do nothing
                end
            else
                prev_continued = false

                # finish previous line segment
                Cairo.set_line_width(ctx, prev_linewidth)
                !isnothing(dash) && Cairo.set_dash(ctx, dash .* prev_linewidth)
                Cairo.set_source_rgba(ctx, red(prev_color), green(prev_color), blue(prev_color), alpha(prev_color))
                Cairo.stroke(ctx)

                if !this_nan
                    this_linewidth != prev_linewidth && error("Encountered two different linewidth values $prev_linewidth and $this_linewidth in `lines` at index $(i - 1). Different linewidths in one line are only permitted in CairoMakie when separated by a NaN point.")
                    # this is not nan
                    # and this color is different than the previous, so move_to prev and line_to this
                    # create gradient pattern and stroke
                    Cairo.move_to(ctx, prev_position...)
                    Cairo.line_to(ctx, this_position...)
                    !isnothing(dash) && Cairo.set_dash(ctx, dash .* this_linewidth)
                    Cairo.set_line_width(ctx, this_linewidth)

                    pat = Cairo.pattern_create_linear(prev_position..., this_position...)
                    Cairo.pattern_add_color_stop_rgba(pat, 0, red(prev_color), green(prev_color), blue(prev_color), alpha(prev_color))
                    Cairo.pattern_add_color_stop_rgba(pat, 1, red(this_color), green(this_color), blue(this_color), alpha(this_color))
                    Cairo.set_source(ctx, pat)
                    Cairo.stroke(ctx)
                    Cairo.destroy(pat)

                    Cairo.move_to(ctx, this_position...)
                else
                    # this is nan, do nothing
                end
            end
        end
        prev_nan = this_nan
        prev_color = this_color
        prev_linewidth = this_linewidth
        prev_position = this_position
    end
    return
end


function draw_single(is_lines_plot::Bool, ctx, positions)
    if is_lines_plot
        return draw_single_lines(ctx, positions)
    else
        return draw_single_segments(ctx, positions)
    end
end

function draw_single_lines(ctx, positions)
    isempty(positions) && return

    n = length(positions)
    start = positions[begin]

    @inbounds for i in 1:n
        p = positions[i]
        # only take action for non-NaNs
        if !isnan(p)
            # new line segment at beginning or if previously NaN
            if i == 1 || isnan(positions[i - 1])
                Cairo.move_to(ctx, p...)
                start = p
            else
                Cairo.line_to(ctx, p...)
                # complete line segment at end or if next point is NaN
                if i == n || isnan(positions[i + 1])
                    if p ≈ start
                        Cairo.close_path(ctx)
                    end
                    Cairo.stroke(ctx)
                end
            end
        end
    end
    # force clearing of path in case of skipped NaN
    return Cairo.new_path(ctx)
end

function draw_single_segments(ctx, positions)

    @assert iseven(length(positions))

    @inbounds for i in 1:2:(length(positions) - 1)
        p1 = positions[i]
        p2 = positions[i + 1]

        if isnan(p1) || isnan(p2)
            continue
        else
            Cairo.move_to(ctx, p1...)
            Cairo.line_to(ctx, p2...)
            Cairo.stroke(ctx)
        end
    end
    # force clearing of path in case of skipped NaN
    return Cairo.new_path(ctx)
end

function draw_bezierpath_lines(ctx, bezierpath::BezierPath, scene, color, space, model, linewidth)
    for c in bezierpath.commands
        if c isa EllipticalArc
            bp = Makie.elliptical_arc_to_beziers(c)
            for bezier in bp.commands
                proj_comm = project_command(bezier, scene, space, model)
                path_command(ctx, proj_comm)
            end
        else
            proj_comm = project_command(c, scene, space, model)
            path_command(ctx, proj_comm)
        end
    end
    Cairo.set_source_rgba(ctx, rgbatuple(color)...)
    Cairo.set_line_width(ctx, linewidth)
    Cairo.stroke(ctx)
    return
end

function project_command(m::MoveTo, scene, space, model)
    return MoveTo(project_position(scene, space, m.p, model))
end

function project_command(l::LineTo, scene, space, model)
    return LineTo(project_position(scene, space, l.p, model))
end

function project_command(c::CurveTo, scene, space, model)
    return CurveTo(
        project_position(scene, space, c.c1, model),
        project_position(scene, space, c.c2, model),
        project_position(scene, space, c.p, model),
    )
end

project_command(c::ClosePath, scene, space, model) = c

function extract_attributes!(attr::ComputeGraph, inputs::Vector{Symbol}, output::Symbol)
    # Make a namedtuple that holds all the attributes we need
    return register_computation!(attr, inputs, [output]) do inputs, changed, outputs
        return (inputs,)
    end
end

################################################################################
#                             Projection utilities                             #
################################################################################

using Makie: apply_transform, transform_func, unclipped_indices, to_model_space,
    broadcast_foreach_index, is_clipped, is_visible

function project_position(scene::Scene, transform_func::T, space::Symbol, point, model::Mat4, yflip::Bool = true) where {T}
    # use transform func
    point = Makie.apply_transform(transform_func, point)
    return _project_position(scene, space, point, model, yflip)
end


function _project_position(scene::Scene, space, ps::AbstractArray{<:VecTypes{N, T1}}, model, yflip::Bool) where {N, T1}
    return project_position(scene, space, ps, eachindex(ps), model, yflip)
end

function cairo_viewport_matrix(res::VecTypes{2}, yflip = true)
    px_scale = Vec3d(0.5 * res[1], 0.5 * (yflip ? -res[2] : res[2]), 1)
    px_offset = Vec3d(0.5 * res[1], 0.5 * res[2], 0)
    return Makie.transformationmatrix(px_offset, px_scale)
end

function build_combined_transformation_matrix(
        scene::Scene, space::Symbol, model::Mat4, yflip = true
    )
    f32convert = Makie.f32_convert_matrix(scene.float32convert, space)
    M = Makie.get_space_to_space_matrix(scene, space, :clip) * f32convert * model
    return cairo_viewport_matrix(scene.camera.resolution[], yflip) * M
end

function project_position(
        scene::Scene, space::Symbol, ps::AbstractArray{<:VecTypes},
        indices::Union{Vector{<:Integer}, Base.OneTo}, model::Mat4,
        yflip::Bool = true
    )
    # much faster to calculate the combined projection-transformation matrix
    # once than dot-ing `project_position` because it skips all the repeated mat * mat
    transform = build_combined_transformation_matrix(scene, space, model, yflip)
    # skip z with Vec(1,2,4), i.e. calculate only (x, y, w)
    return project_position(Point2f, transform[Vec(1, 2, 4), Vec(1, 2, 3, 4)], ps, indices)
end

# Assumes (transform * ps[i])[end] to be w component, always
function project_position(
        ::Type{PT}, transform::Mat{M, 4}, ps::AbstractVector{<:VecTypes},
        indices::Vector{<:Integer}
    ) where {N, PT <: VecTypes{N}, M}

    output = Vector{PT}(undef, length(indices))
    dims = Vec(ntuple(identity, N))

    @inbounds for (i_out, i_in) in enumerate(indices)
        p4d = to_ndim(Point4d, to_ndim(Point3d, ps[i_in], 0), 1)
        px_pos = transform * p4d
        output[i_out] = px_pos[dims] / px_pos[end]
    end

    return output
end
function project_position(
        ::Type{PT}, transform::Mat{M, 4}, ps::AbstractArray{<:VecTypes},
        indices::Base.OneTo
    ) where {N, PT <: VecTypes{N}, M}

    output = similar(ps, PT)
    dims = Vec(ntuple(identity, N))

    @inbounds for i in indices
        p4d = to_ndim(Point4d, to_ndim(Point3d, ps[i], 0), 1)
        px_pos = transform * p4d
        output[i] = px_pos[dims] / px_pos[end]
    end

    return output
end

function _project_position(scene::Scene, space, point::VecTypes{N, T1}, model, yflip::Bool) where {N, T1 <: Real}
    T = promote_type(Float32, T1) # always Float, at least Float32
    res = scene.camera.resolution[]
    p4d = to_ndim(Vec4{T}, to_ndim(Vec3{T}, point, 0), 1)
    f32convert = Makie.f32_convert_matrix(scene.float32convert, space)
    clip = Makie.space_to_clip(scene.camera, space) * f32convert * model * p4d
    @inbounds begin
        # between -1 and 1
        p = (clip ./ clip[4])[Vec(1, 2)]
        # flip y to match cairo
        p_yflip = Vec2f(p[1], (1.0f0 - 2.0f0 * yflip) * p[2])
        # normalize to between 0 and 1
        p_0_to_1 = (p_yflip .+ 1.0f0) ./ 2.0f0
    end
    # multiply with scene resolution for final position
    return p_0_to_1 .* res
end


function project_position(@nospecialize(scenelike), space, point, model, yflip::Bool = true)
    scene = Makie.get_scene(scenelike)
    return project_position(scene, Makie.transform_func(scenelike), space, point, model, yflip)
end


function project_shape(@nospecialize(scenelike), space, rect::Rect, model)
    # Note that this assumes the Rect to remain axis-aligned through transformations
    # clamp to prevent float issues from switching to widths = maxi .- mini
    res = Makie.get_scene(scenelike).camera.resolution[]
    mini = clamp.(project_position(scenelike, space, minimum(rect), model), -res, 2 .* res)
    maxi = clamp.(project_position(scenelike, space, maximum(rect), model), -res, 2 .* res)
    return Rect(mini, maxi .- mini)
end

function clip_poly(clip_planes::Vector{Plane3f}, ps::AbstractVector{PT}, space::Symbol, model::Mat4) where {PT <: VecTypes{2}}
    if isempty(clip_planes) || !Makie.is_data_space(space)
        return ps
    end

    planes = to_model_space(model, clip_planes)
    last_distance = Makie.min_clip_distance(planes, first(ps))
    last_point = first(ps)
    output = sizehint!(PT[], length(ps))

    for p in ps
        d = Makie.min_clip_distance(planes, p)
        if (last_distance < 0) && (d >= 0) # clipped -> unclipped
            # point between last and this on clip plane
            clip_point = - last_distance * (p - last_point) / (d - last_distance) + last_point
            push!(output, clip_point, p)
        elseif (last_distance >= 0) && (d < 0) # unclipped -> clipped
            clip_point = - last_distance * (p - last_point) / (d - last_distance) + last_point
            push!(output, clip_point)
        elseif (last_distance >= 0) && (d >= 0) # unclipped -> unclipped
            push!(output, p)
        end
        last_point = p
        last_distance = d
    end

    return output
end

function clip_shape(clip_planes::Vector{Plane3f}, shape::Rect2, space::Symbol, model::Mat4)
    if !Makie.is_data_space(space) || isempty(clip_planes)
        return shape
    end

    xy = origin(shape)
    w, h = widths(shape)
    ps = Point2d[xy, xy + Vec2d(w, 0), xy + Vec2d(w, h), xy + Vec2d(0, h)]
    if any(p -> Makie.is_clipped(clip_planes, p), ps)
        push!(ps, xy)
        ps = clip_poly(clip_planes, ps, space, model)
        commands = Makie.PathCommand[MoveTo(ps[1]), LineTo.(ps[2:end])..., ClosePath()]
        return BezierPath(commands::Vector{Makie.PathCommand})
    else
        return shape
    end
end

function clip_shape(clip_planes::Vector{Plane3f}, shape::BezierPath, space::Symbol, model::Mat4)
    return shape
end

function project_polygon(@nospecialize(scenelike), space, poly::Polygon{N, T}, clip_planes, model) where {N, T}
    PT = Point{N, Makie.float_type(T)}
    ext = decompose(PT, poly.exterior)
    project(p) = PT(project_position(scenelike, space, p, model))

    ext_proj = PT[project(p) for p in clip_poly(clip_planes, ext, space, model)]
    interiors_proj = Vector{PT}[
        PT[project(p) for p in clip_poly(clip_planes, decompose(PT, points), space, model)]
            for points in poly.interiors
    ]

    return Polygon(ext_proj, interiors_proj)
end

function project_multipolygon(@nospecialize(scenelike), space, multipoly::MP, clip_planes, model) where {MP <: MultiPolygon}
    return MultiPolygon(project_polygon.(Ref(scenelike), Ref(space), multipoly.polygons, Ref(clip_planes), Ref(model)))
end

scale_matrix(x, y) = Cairo.CairoMatrix(x, 0.0, 0.0, y, 0.0, 0.0)

function clip2screen(p, res)
    s = Vec2f(0.5f0, -0.5f0) .* p[Vec(1, 2)] / p[4] .+ 0.5f0
    return res .* s
end


########################################
#          Rotation handling           #
########################################

function to_2d_rotation(x)
    quat = to_rotation(x)
    return -Makie.quaternion_to_2d_angle(quat)
end

function to_2d_rotation(::Makie.Billboard)
    @warn "This should not be reachable!"
    return 0
end

remove_billboard(x) = x
remove_billboard(b::Makie.Billboard) = b.rotation

to_2d_rotation(quat::Makie.Quaternion) = -Makie.quaternion_to_2d_angle(quat)

# TODO: this is a hack around a hack.
# Makie encodes the transformation from a 2-vector
# to a quaternion as a rotation around the Y-axis,
# when it should be a rotation around the X-axis.
# Since I don't know how to fix this in GLMakie,
# I've reversed the order of arguments to atan,
# such that our behaviour is consistent with GLMakie's.
to_2d_rotation(vec::Vec2f) = atan(vec[1], vec[2])

to_2d_rotation(n::Real) = n


################################################################################
#                                Color handling                                #
################################################################################

function rgbatuple(c::Colorant)
    rgba = RGBA(c)
    return red(rgba), green(rgba), blue(rgba), alpha(rgba)
end

function rgbatuple(c)
    colorant = to_color(c)
    if !(colorant isa Colorant)
        error("Can't convert $(c) to a colorant")
    end
    return rgbatuple(colorant)
end

premultiplied_rgba(a::AbstractArray{<:ColorAlpha}) = map(premultiplied_rgba, a)
premultiplied_rgba(a::AbstractArray{<:Color}) = RGBA.(a)
premultiplied_rgba(r::RGBA) = RGBA(r.r * r.alpha, r.g * r.alpha, r.b * r.alpha, r.alpha)
premultiplied_rgba(c::Colorant) = premultiplied_rgba(RGBA(c))

to_uint32_color(c) = reinterpret(UInt32, convert(ARGB32, premultiplied_rgba(c)))

# handle patterns
function Cairo.CairoPattern(color::Makie.AbstractPattern)
    # the Cairo y-coordinate are flipped
    bitmappattern = reverse(Makie.to_image(color); dims = 2)
    # Cairo wants pre-multiplied alpha - ARGB32 doesn't do that on its own
    bitmappattern = map(bitmappattern) do c
        a = alpha(c)
        return ARGB32(a * red(c), a * green(c), a * blue(c), a)
    end
    cairoimage = Cairo.CairoImageSurface(bitmappattern)
    cairopattern = Cairo.CairoPattern(cairoimage)
    Cairo.pattern_set_extend(cairopattern, Cairo.EXTEND_REPEAT)
    return cairopattern
end

function align_pattern(pattern::Cairo.CairoPattern, scene, model)
    o = Makie.pattern_offset(scene.camera.projectionview[] * model, scene.camera.resolution[], true)
    T = Mat{2, 3, Float32}(1, 0, 0, 1, -o[1], -o[2])
    pattern_set_matrix(pattern, Cairo.CairoMatrix(T...))
    return
end

########################################
#        Common color utilities        #
########################################

function to_cairo_color(colors::Union{AbstractVector, Number}, plot_object)
    cmap = Makie.assemble_colors(colors, Observable(colors), plot_object)
    return to_color(to_value(cmap))
end

function to_cairo_color(color::Makie.AbstractPattern, plot)
    cairopattern = Cairo.CairoPattern(color)
    # This should be reset after drawing
    align_pattern(cairopattern, Makie.parent_scene(plot), plot.model[])
    return cairopattern
end

function to_cairo_color(color, plot_object)
    return to_color((color, to_value(plot_object.alpha)))
end

function set_source(ctx::Cairo.CairoContext, pattern::Cairo.CairoPattern)
    return Cairo.set_source(ctx, pattern)
end

function set_source(ctx::Cairo.CairoContext, color::Colorant)
    return Cairo.set_source_rgba(ctx, rgbatuple(color)...)
end

#######################################
#        Stroking properties          #
#######################################

function to_cairo_linecap(linecap_symb::Symbol)
    linecap = Makie.convert_attribute(linecap_symb, key"linecap"())
    return to_cairo_linecap(linecap)
end
function to_cairo_linecap(linecap)
    if linecap == 1
        return Cairo.CAIRO_LINE_CAP_SQUARE
    elseif linecap == 2
        return Cairo.CAIRO_LINE_CAP_ROUND
    elseif linecap == 0
        return Cairo.CAIRO_LINE_CAP_BUTT
    else
        error("$linecap is not a valid linecap. Valid: 0 (:butt), 1 (:square), 2 (:round)")
    end
end

function to_cairo_joinstyle(joinstyle_symb::Symbol)
    joinstyle = Makie.convert_attribute(joinstyle_symb, key"joinstyle"())
    return to_cairo_joinstyle(joinstyle)
end
function to_cairo_joinstyle(joinstyle)
    if joinstyle == 2
        return Cairo.CAIRO_LINE_JOIN_ROUND
    elseif joinstyle == 3
        return Cairo.CAIRO_LINE_JOIN_BEVEL
    elseif joinstyle == 0
        return Cairo.CAIRO_LINE_JOIN_MITER
    else
        error("$joinstyle is not a valid linecap. Valid: 0 (:miter), 2 (:round), 3 (:bevel)")
    end
end

function to_cairo_miter_limit(miter_limit)
    return 2.0f0 * Makie.miter_angle_to_distance(miter_limit)
end

to_cairo_linestyle(::Nothing, ::Any) = nothing
to_cairo_linestyle(::AbstractVector, ::AbstractArray) = nothing
function to_cairo_linestyle(linestyle::AbstractVector, linewidth::Real)
    # There is a discrepancy between Makie and Cairo when it comes to linestyles.
    # For Makie, the linestyle array is cumulative, and defines the "absolute"
    # endpoints of segments. However, for Cairo, each value provides the length of
    # alternate "on" and "off" portions of the stroke. Therefore, we take the
    # diff of the given linestyle, to convert the "absolute" coordinates into
    # "relative" ones.
    pattern = diff(Float64.(linestyle)) .* linewidth
    isodd(length(pattern)) && push!(pattern, 0)
    return pattern
end

########################################
#        Marker conversion API         #
########################################

"""
    cairo_scatter_marker(marker)

Convert a Makie marker to a Cairo-compatible marker.  This defaults to calling
`Makie.to_spritemarker`, but can be overridden for specific markers that can
be directly rendered to vector formats using Cairo.
"""
cairo_scatter_marker(marker) = Makie.to_spritemarker(marker)

########################################
#     Image/heatmap -> ARGBSurface     #
########################################


to_cairo_image(img::AbstractMatrix{<:Colorant}) = to_cairo_image(to_uint32_color.(img))

function to_cairo_image(img::AbstractMatrix{UInt32})
    # we need to convert from column-major to row-major storage,
    # therefore we permute x and y
    return Cairo.CairoARGBSurface(convert(Matrix, permutedims(img)))
end


################################################################################
#                                Mesh handling                                 #
################################################################################

struct FaceIterator{Iteration, T, F, ET} <: AbstractVector{ET}
    data::T
    faces::F
end

function (::Type{FaceIterator{Typ}})(data::T, faces::F) where {Typ, T, F}
    return FaceIterator{Typ, T, F}(data, faces)
end
function (::Type{FaceIterator{Typ, T, F}})(data::AbstractVector, faces::F) where {Typ, F, T}
    return FaceIterator{Typ, T, F, NTuple{3, eltype(data)}}(data, faces)
end
function (::Type{FaceIterator{Typ, T, F}})(data::T, faces::F) where {Typ, T, F}
    return FaceIterator{Typ, T, F, NTuple{3, T}}(data, faces)
end
function FaceIterator(data::AbstractVector, faces)
    return if length(data) == length(faces)
        FaceIterator{:PerFace}(data, faces)
    else
        FaceIterator{:PerVert}(data, faces)
    end
end

Base.size(fi::FaceIterator) = size(fi.faces)
Base.getindex(fi::FaceIterator{:PerFace}, i::Integer) = fi.data[i]
Base.getindex(fi::FaceIterator{:PerVert}, i::Integer) = fi.data[fi.faces[i]]
Base.getindex(fi::FaceIterator{:Const}, i::Integer) = ntuple(i -> fi.data, 3)

color_or_nothing(c) = isnothing(c) ? nothing : to_color(c)
function get_color_attr(attributes, attribute)::Union{Nothing, RGBAf}
    return color_or_nothing(to_value(get(attributes, attribute, nothing)))
end

function per_face_colors(_color, matcap, faces, normals, uv)
    color = to_color(_color)
    if !isnothing(matcap)
        wsize1 = reverse(size(matcap::Matrix{RGBAf}))
        wh1 = wsize1 .- 1
        cvec = map(normals) do n
            muv = 0.5n[Vec(1, 2)] .+ Vec2f(0.5)
            x, y = clamp.(round.(Int, Tuple(muv) .* wh1) .+ 1, 1, wh1)
            return matcap[end - (y - 1), x]
        end
        return FaceIterator(cvec, faces)
    elseif color isa Colorant
        return FaceIterator{:Const}(color::RGBAf, faces)
    elseif color isa AbstractVector{<:Colorant}
        return FaceIterator{:PerVert}(color::Vector{RGBAf}, faces)
    elseif color isa Makie.AbstractPattern
        return Cairo.CairoPattern(color)
    elseif color isa Makie.ShaderAbstractions.Sampler # currently target for AbstractPattern
        @assert color.repeat === (:repeat, :repeat)
        return Cairo.CairoPattern(Makie.ImagePattern(color.data))
    elseif color isa AbstractMatrix{<:Colorant} && !isnothing(uv)
        wsize2 = size(color::Matrix{RGBAf})
        wh2 = wsize2 .- 1
        # nearest
        cvec = map(uv::Vector{Vec2f}) do uv
            x, y = clamp.(round.(Int, uv .* wh2) .+ 1, 1, wsize2)
            return color[x, y]::RGBAf
        end
        # TODO This is wrong and doesn't actually interpolate
        # Inside the triangle sampling the color image
        return FaceIterator(cvec, faces)
    elseif color isa AbstractArray{<:Any, 3}
        error("Volume texture only supported in GLMakie right now")
    end

    error("Unsupported Color type: $(typeof(color))")
end

function mesh_pattern_set_corner_color(pattern, id, c::Colorant)
    return Cairo.mesh_pattern_set_corner_color_rgba(pattern, id, rgbatuple(c)...)
end

################################################################################
#                                Font handling                                 #
################################################################################


"""
Finds a font that can represent the unicode character!
Returns Makie.defaultfont() if not representable!
"""
function best_font(c::Char, font = Makie.defaultfont())
    if Base.@lock font.lock Makie.FreeType.FT_Get_Char_Index(font, c) == 0
        for afont in Makie.alternativefonts()
            if Base.@lock afont.lock Makie.FreeType.FT_Get_Char_Index(afont, c) != 0
                return afont
            end
        end
        return Makie.defaultfont()
    end
    return font
end

is_approx_zero(x) = isapprox(x, 0)
is_approx_zero(v::VecTypes) = any(x -> isapprox(x, 0), v)

function is_degenerate(M::Mat2f)
    v1 = M[Vec(1, 2), 1]
    v2 = M[Vec(1, 2), 2]
    l1 = dot(v1, v1)
    l2 = dot(v2, v2)
    # Bad cases:   nan   ||     0 vector     ||   linearly dependent
    return any(isnan, M) || l1 ≈ 0 || l2 ≈ 0 || dot(v1, v2)^2 ≈ l1 * l2
end

zero_normalize(v::AbstractVector{T}) where {T} = v ./ (norm(v) + eps(zero(T)))

function cairo_project_to_screen_impl(projectionview, resolution, model, pos, output_type = Point2f, yflip = true)
    # the existing methods include f32convert matrices which are already
    # applied in :positions_transformed_f32c (using this makes CairoMakie
    # less performant (extra O(N) step) but allows code reuse with other backends)
    M = cairo_viewport_matrix(resolution, yflip) * projectionview * model
    return project_position(output_type, M, pos, eachindex(pos))
end

function cairo_project_to_screen_impl(projectionview, resolution, model, pos::VecTypes, output_type = Point2f, yflip = true)
    p4d = to_ndim(Point4d, to_ndim(Point3d, pos, 0), 1)
    p4d = model * p4d
    p4d = projectionview * p4d
    p4d = cairo_viewport_matrix(resolution, yflip) * p4d
    return output_type(p4d) / p4d[4]
end


function cairo_project_to_screen(
        attr;
        input_name = :positions_transformed_f32c, yflip = true, output_type = Point2f
    )
    Makie.register_computation!(
        attr,
        [:projectionview, :resolution, :model_f32c, input_name], [:cairo_screen_pos]
    ) do inputs, changed, cached

        output = cairo_project_to_screen_impl(values(inputs)..., output_type, yflip)
        return (output,)
    end

    return attr[:cairo_screen_pos][]
end

function draw_atomic(scene::Scene, screen::Screen, primitive::Makie.Mesh)
    Makie.compute_colors!(primitive.attributes)
    if Makie.cameracontrols(scene) isa Union{Camera2D, Makie.PixelCamera, Makie.EmptyCamera}
        draw_mesh2D(scene, screen, primitive.attributes)
    else
        draw_mesh3D(scene, screen, primitive.attributes)
    end
    return nothing
end

function draw_mesh2D(scene, screen, attr::ComputeGraph)
    # TODO: no clip_planes?
    vs = cairo_project_to_screen(attr)
    fs = attr.faces[]
    uv = attr.texturecoordinates[]
    uv_transform = attr.pattern_uv_transform[]
    if uv isa Vector{Vec2f} && to_value(uv_transform) !== nothing
        uv = map(uv -> uv_transform * to_ndim(Vec3f, uv, 1), uv)
    end
    color = compute_colors(attr)
    cols = per_face_colors(color, nothing, fs, nothing, uv)
    if cols isa Cairo.CairoPattern
        align_pattern(cols, scene, attr.model[])
    end
    return draw_mesh2D(screen, cols, vs, fs)
end


function draw_mesh2D(screen, color, vs::Vector, fs::Vector{GLTriangleFace})
    return draw_mesh2D(screen.context, color, vs, fs)
end

function flush_pattern(ctx, pattern, reopen = true)
    Cairo.set_source(ctx, pattern)
    Cairo.close_path(ctx)
    Cairo.paint(ctx)
    Cairo.destroy(pattern)
    # Reset any lingering pattern state
    Cairo.set_source_rgba(ctx, 0, 0, 0, 1)

    if reopen
        pattern = Cairo.CairoPatternMesh()
    end

    return pattern
end

const MAX_PATCHES_PER_PATTERN = Ref{Int64}(16384)  # TODO: tune

function draw_mesh2D(ctx::Cairo.CairoContext, per_face_cols, vs::Vector, fs::Vector{GLTriangleFace})
    # Prioritize colors of the mesh if present
    # This is a hack, which needs cleaning up in the Mesh plot type!

    cnt = 0
    flusheach = MAX_PATCHES_PER_PATTERN[]
    pattern = Cairo.CairoPatternMesh()

    for i in eachindex(fs)
        c1, c2, c3 = per_face_cols[i]
        t1, t2, t3 = vs[fs[i]] #triangle points

        # don't draw any mesh faces with NaN components.
        if isnan(t1) || isnan(t2) || isnan(t3)
            continue
        end

        cnt += 1
        Cairo.mesh_pattern_begin_patch(pattern)

        Cairo.mesh_pattern_move_to(pattern, t1[1], t1[2])
        Cairo.mesh_pattern_line_to(pattern, t2[1], t2[2])
        Cairo.mesh_pattern_line_to(pattern, t3[1], t3[2])

        mesh_pattern_set_corner_color(pattern, 0, c1)
        mesh_pattern_set_corner_color(pattern, 1, c2)
        mesh_pattern_set_corner_color(pattern, 2, c3)

        Cairo.mesh_pattern_end_patch(pattern)

        if cnt % flusheach == 0
            pattern = flush_pattern(ctx, pattern)
        end
    end

    if cnt % flusheach != 0
        flush_pattern(ctx, pattern, false)
    end
    return nothing
end

function draw_mesh2D(ctx::Cairo.CairoContext, pattern::Cairo.CairoPattern, vs::Vector, fs::Vector{GLTriangleFace})
    # Prioritize colors of the mesh if present
    # This is a hack, which needs cleaning up in the Mesh plot type!
    Cairo.set_source(ctx, pattern)

    for i in eachindex(fs)
        t1, t2, t3 = vs[fs[i]] # triangle points

        # don't draw any mesh faces with NaN components.
        if isnan(t1) || isnan(t2) || isnan(t3)
            continue
        end

        # TODO:
        # - this may create gaps like heatmap?
        # - for some reason this is liqhter than it should be?
        Cairo.move_to(ctx, t1[1], t1[2])
        Cairo.line_to(ctx, t2[1], t2[2])
        Cairo.line_to(ctx, t3[1], t3[2])
        Cairo.close_path(ctx)
        Cairo.fill(ctx)
    end
    pattern_set_matrix(pattern, Cairo.CairoMatrix(1, 0, 0, 1, 0, 0))
    return nothing
end

function average_z(positions, face)
    vs = positions[face]
    return sum(v -> v[3], vs) / length(vs)
end

function strip_translation(M::Mat4{T}) where {T}
    return @inbounds Mat4{T}(
        M[1], M[2], M[3], M[4],
        M[5], M[6], M[7], M[8],
        M[9], M[10], M[11], M[12],
        0, 0, 0, M[16],
    )
end

function _calculate_shaded_vertexcolors(N, v, c, lightdir, light_color, ambient, diffuse, specular, shininess)
    L = lightdir
    diff_coeff = max(dot(L, -N), 0.0f0)
    H = normalize(L + v)
    spec_coeff = max(dot(H, -N), 0.0f0)^shininess
    c = RGBAf(c)
    # if this is one expression it introduces allocations??
    new_c_part1 = (ambient .+ light_color .* diff_coeff .* diffuse) .* Vec3f(c.r, c.g, c.b) #.+
    new_c = new_c_part1 .+ light_color .* specular * spec_coeff
    return RGBAf(new_c..., c.alpha)
end

function draw_pattern(ctx, zorder, shading, meshfaces, ts, per_face_col, ns, vs, viewdir, lightdir, light_color, shininess, diffuse, ambient, specular)
    #=
    TODO:
    Rendering just a few Cairo patterns containing many faces/patches (like the
    2D version) is much faster than rendering one pattern per face, but it also
    causes those faces to no longer drawn over each other. A transparent mesh
    therefore doesn't render correctly (doesn't render front *and* backside or
    self-overlap).

    Flushing the pattern whenever we switch between front and back facing
    triangles fixes the rendering issue, but often creates performance issues.
    It seems like Cairo can handle large patterns and lots of single element
    pattern decently well, but not many patterns of varying size (which you get
    for more or less everything that's not a sphere). So we just keep it at 1
    face per pattern here.
    =#

    for k in reverse(zorder)

        f = meshfaces[k]
        # avoid SizedVector through Face indexing
        t1 = ts[f[1]]
        t2 = ts[f[2]]
        t3 = ts[f[3]]

        # skip any mesh segments with NaN points.
        if isnan(t1) || isnan(t2) || isnan(t3)
            continue
        end

        facecolors = per_face_col[k]
        # light calculation
        if shading && !isnothing(ns)
            # these face index expressions currently allocate for SizedVectors
            # if done like `ns[f]`
            mean_normal = sum(i -> ns[i], f) / length(f)
            c1, c2, c3 = Base.Cartesian.@ntuple 3 i -> begin
                # normals are usually interpolated on the face, which allows
                # Vec3f(0) to be used to give a vertex no weight on the normal
                # direction. To reproduce this here we mix in a tiny amount of
                # the mean normal direction.
                N = normalize(ns[f[i]] + 1.0e-20 * mean_normal)
                v = vs[f[i]]
                c = facecolors[i]
                _calculate_shaded_vertexcolors(N, v, c, lightdir, light_color, ambient, diffuse, specular, shininess)
            end
        else
            c1, c2, c3 = facecolors
        end

        # debug normal coloring
        # n1, n2, n3 = Vec3f(0.5) .+ 0.5ns[f]
        # c1 = RGB(n1...)
        # c2 = RGB(n2...)
        # c3 = RGB(n3...)

        pattern = Cairo.CairoPatternMesh()

        Cairo.mesh_pattern_begin_patch(pattern)

        Cairo.mesh_pattern_move_to(pattern, t1[1], t1[2])
        Cairo.mesh_pattern_line_to(pattern, t2[1], t2[2])
        Cairo.mesh_pattern_line_to(pattern, t3[1], t3[2])

        mesh_pattern_set_corner_color(pattern, 0, c1)
        mesh_pattern_set_corner_color(pattern, 1, c2)
        mesh_pattern_set_corner_color(pattern, 2, c3)

        Cairo.mesh_pattern_end_patch(pattern)

        flush_pattern(ctx, pattern, false)
    end

    return
end

# Still used for voxels
function _transform_to_world(scene::Scene, @nospecialize(plot), pos)
    space = plot.space[]::Symbol
    model = plot.model[]::Mat4d
    f32_model = Makie.f32_convert_matrix(scene.float32convert, space) * model
    tf = Makie.transform_func(plot)
    return _transform_to_world(f32_model, tf, pos)
end

function _transform_to_world(f32_model, tf, pos)
    return map(pos) do p
        transformed = Makie.apply_transform(tf, p)
        p4d = to_ndim(Point4d, to_ndim(Point3d, transformed, 0), 1)
        p4d = f32_model * p4d
        return p4d[Vec(1, 2, 3)] / p4d[4]
    end
end


# Mesh + surface entry point
function draw_mesh3D(scene, screen, plot::ComputeGraph)
    clip_planes = plot.clip_planes[]::Vector{Plane3f}
    uv_transform = plot.pattern_uv_transform[]::Union{Nothing, Mat{2, 3, Float32, 6}}

    # per-element in meshscatter
    world_points = Makie.apply_model(
        plot.model_f32c[]::Mat4f,
        plot.positions_transformed_f32c[]::Union{Vector{Point3f}, Vector{Point2f}}
    )
    screen_points = cairo_project_to_screen(plot, output_type = Point3f)::Vector{Point3f}
    meshfaces = plot.faces[]::Vector{GLTriangleFace}
    meshnormals = plot.normals[]::Union{Nothing, Vector{Vec3f}}
    _meshuvs = plot.texturecoordinates[]

    if (_meshuvs isa AbstractVector{<:Vec3})
        error("Only 2D texture coordinates are supported right now. Use GLMakie for 3D textures.")
    end
    meshuvs::Union{Nothing, Vector{Vec2f}} = _meshuvs

    color = compute_colors(plot)

    return draw_mesh3D(
        scene, screen, plot,
        world_points, screen_points, meshfaces, meshnormals, meshuvs,
        uv_transform, color, clip_planes
    )
end

function draw_mesh3D(
        scene, screen, plot::ComputeGraph,
        world_points, screen_points, meshfaces, meshnormals, meshuvs,
        uv_transform, color, clip_planes, model = plot.model_f32c[]::Mat4f
    )

    local shading::Bool = plot.shading[] && (scene.compute.shading[] != NoShading)

    if meshuvs isa Vector{Vec2f} && uv_transform !== nothing
        uvt = uv_transform::Mat{2, 3, Float32, 6}
        meshuvs = map(uv -> uvt * to_ndim(Vec3f, uv, 1), meshuvs)
    end

    matcap::Union{Nothing, Matrix{RGBAf}} = to_value(get(plot, :matcap, nothing))
    space = plot.space[]::Symbol

    # Fall back onto mesh2D for meshes with a Makie.AbstractPattern
    if isnothing(matcap) && plot.fetch_pixel[]::Bool
        pattern = per_face_colors(color, nothing, meshfaces, meshnormals, meshuvs)::Cairo.CairoPattern
        # plot.model_f32c[] is f32c corrected, not f32c * model
        f32c_model = Makie.f32_convert_matrix(scene.float32convert, space) * (plot.model[]::Mat4d)
        align_pattern(pattern, scene, f32c_model)
        return draw_mesh2D(screen.context, pattern, screen_points, meshfaces)
    end

    per_face_col = per_face_colors(
        color::Union{RGBAf, Vector{RGBAf}, Matrix{RGBAf}},
        matcap, meshfaces, meshnormals, meshuvs
    )

    local faceculling::Int = to_value(get(plot, :faceculling, -10))

    return draw_mesh3D(
        scene, screen, space, world_points, screen_points, meshfaces, meshnormals, per_face_col,
        model, shading, plot.diffuse[]::Vec3f,
        plot.specular[]::Vec3f, plot.shininess[]::Float32, faceculling,
        clip_planes, plot.eyeposition[]::Vec3f
    )
end

to_vec(c::Colorant) = Vec3f(red(c), green(c), blue(c))
prepare_normals(normalmatrix::Mat3f, normals::Nothing) = nothing
function prepare_normals(normalmatrix::Mat3f, normals::Vector{Vec3f})
    return [zero_normalize(normalmatrix * normal) for normal in normals]
end

function draw_mesh3D(
        scene, screen, space, world_points, screen_points, meshfaces, meshnormals, per_face_col,
        model, shading, diffuse, specular, shininess, faceculling, clip_planes, eyeposition
    )
    ctx = screen.context

    # local_model applies rotation and markersize from meshscatter to vertices
    i = Vec(1, 2, 3)
    normalmatrix = transpose(inv(Mat3f(model[i, i]))) # see issue #3702
    ns = prepare_normals(normalmatrix, meshnormals)

    # Approximate zorder
    average_zs = map(f -> average_z(screen_points, f), meshfaces)
    zorder = sortperm(average_zs)

    # cull faces that contain clipped vertices
    if Makie.is_data_space(space) && !isempty(clip_planes)
        valid = Bool[is_visible(clip_planes, p) for p in world_points]
        filter!(zorder) do face_index
            face = meshfaces[face_index]
            return all(vertex_index -> valid[vertex_index], face)
        end
    end

    # cull faces with backfacing normals (as defined by faceculling)
    viewdir = scene.camera.view_direction[]::Vec3f
    if !isnothing(ns)
        filter!(zorder) do face_index
            face = meshfaces[face_index]
            return any(vertex_index -> dot(-ns[vertex_index], viewdir) > faceculling, face)
        end
    end

    ambient = to_vec(scene.compute[:ambient_color][])
    light_color = to_vec(scene.compute[:dirlight_color][])
    light_direction = scene.compute[:dirlight_final_direction][]::Vec3f

    # vs are used as camdir (camera to vertex) for light calculation (in world space)
    vs = map(v -> normalize(to_ndim(Point3f, v, 0) - eyeposition), world_points)

    draw_pattern(
        ctx, zorder, shading, meshfaces, screen_points, per_face_col, ns, vs, viewdir,
        light_direction, light_color, shininess, diffuse, ambient, specular
    )

    return
end

function draw_atomic(scene::Scene, screen::Screen, @nospecialize(plot::Makie.MeshScatter))
    # We combine vertices and positions in world space.
    # Here we do the transformation to world space of meshscatter args
    # The rest happens in draw_scattered_mesh()
    transformed_pos = Makie.apply_model(
        plot.model_f32c[]::Mat4f,
        plot.positions_transformed_f32c[]::Union{Vector{Point2f}, Vector{Point3f}}
    )
    colors = compute_colors(plot)
    uv_transform = plot.pattern_uv_transform[]

    return draw_scattered_mesh(
        scene, screen, plot.attributes, plot.marker[],
        transformed_pos, plot.markersize[], plot.rotation[], colors,
        plot.clip_planes[], plot.transform_marker[]::Bool, uv_transform
    )
end

function draw_scattered_mesh(
        scene, screen, plot::ComputeGraph, mesh,
        # positions in world space, acting as translations for mesh
        positions, scales, rotations, colors,
        clip_planes, transform_marker, uv_transform
    )
    space = plot.space[]

    meshpoints = decompose(Point3f, mesh)
    meshfaces = decompose(GLTriangleFace, mesh)
    meshnormals = normals(mesh)
    meshuvs = texturecoordinates(mesh)

    # transformation matrix to mesh into world space, see loop
    f32c_model = ifelse(transform_marker, strip_translation(plot.model[]::Mat4d), Mat4d(I))
    if !isnothing(scene.float32convert) && Makie.is_data_space(space)
        f32c_model = Makie.scalematrix(scene.float32convert.scaling[].scale::Vec3d) * f32c_model
    end

    # Z sorting based on meshscatter arguments
    # For correct z-ordering we need to be in view/camera or screen space
    view = plot.view[]::Mat4f
    zorder = sortperm(
        positions, by = p -> begin
            p4d = to_ndim(Vec4d, p, 1)
            cam_pos = view[Vec(3, 4), Vec(1, 2, 3, 4)] * p4d
            cam_pos[1] / cam_pos[2]
        end, rev = false
    )

    proj_mat = cairo_viewport_matrix(plot.resolution[]) * plot.projectionview[]

    for i in zorder
        # Get per-element data
        element_color = Makie.sv_getindex(colors, i)
        element_uv_transform = Makie.sv_getindex(uv_transform, i)
        element_translation = to_ndim(Point4d, positions[i], 0)
        element_rotation = Makie.rotationmatrix4(Makie.sv_getindex(rotations, i))
        element_scale = Makie.sv_getindex(scales, i)
        element_scale_matrix = Makie.scalematrix(element_scale)
        # different order from transformationmatrix()
        element_transform = f32c_model * element_rotation * element_scale_matrix

        # Note: These are not part of the compute graph because the number of
        # vertices of the mesh * number of positions in meshscatter could become
        # quite large

        # mesh transformations
        # - transform_func does not apply to vertices (only pos)
        # - only scaling from float32convert applies to vertices
        #   f32c_scale * (maybe model) *  rotation * scale * vertices  +  f32c * model * transform_func(plot[1])
        # =        f32c_model          * element_transform * vertices  +       element_translation
        element_world_pos = map(meshpoints) do p
            p4d = to_ndim(Point4d, to_ndim(Point3d, p, 0), 1)
            p4d = element_transform * p4d + element_translation
            return Point3f(p4d) / p4d[4]
        end

        element_screen_pos = project_position(Point3f, proj_mat, element_world_pos, eachindex(element_world_pos))

        # only used for normals
        finite_element_scale = @. ifelse(element_scale >= 0, +1, -1) * max(abs(element_scale), 1.0e-6)
        model = f32c_model * element_rotation * Makie.scalematrix(finite_element_scale)

        draw_mesh3D(
            scene, screen, plot,
            element_world_pos, element_screen_pos, meshfaces, meshnormals, meshuvs,
            element_uv_transform, element_color, clip_planes, model
        )
    end

    return nothing
end


function draw_atomic(scene::Scene, screen::Screen, plot::Makie.Surface)
    attr = plot.attributes
    Makie.add_computation!(attr, Val(:surface_as_mesh))
    Makie.register_pattern_uv_transform!(attr)

    draw_mesh3D(scene, screen, attr)
    return nothing
end


function draw_atomic(scene::Scene, screen::Screen, @nospecialize(primitive::Makie.Voxels))
    pos = Makie.voxel_positions(primitive)
    scale = Makie.voxel_size(primitive)
    colors = Makie.voxel_colors(primitive)
    marker = GeometryBasics.expand_faceviews(normal_mesh(Rect3f(Point3f(-0.5), Vec3f(1))))

    # transformation to world space
    transformed_pos = _transform_to_world(scene, primitive, pos)

    # clip full voxel instead of faces
    clip_planes = primitive.clip_planes[]::Vector{Plane3f}
    if !isempty(clip_planes) && Makie.is_data_space(primitive)
        valid = [is_visible(clip_planes, p) for p in transformed_pos]
        transformed_pos = transformed_pos[valid]
        colors = colors[valid]
    end

    # sneak in model_f32c so we don't have to pass through another variable
    Makie.register_computation!(primitive.attributes::Makie.ComputeGraph, [:model], [:model_f32c]) do (model,), _, __
        return (Mat4f(model),)
    end

    draw_scattered_mesh(
        scene, screen, primitive.attributes, marker,
        transformed_pos, scale, Quaternionf(0, 0, 0, 1), colors,
        Plane3f[], true, primitive.uv_transform[]
    )

    return nothing
end

function draw_atomic(scene::Scene, screen::Screen, plot::Scatter)
    attr = plot.attributes
    isempty(attr.positions[]) && return
    Makie.add_computation!(attr, scene, Val(:meshscatter_f32c_scale))
    cairo_unclipped_indices!(attr)
    Makie.compute_colors!(attr)
    Makie.register_positions_projected!(
        scene.compute, attr, Point3d;
        input_name = :positions_transformed_f32c, output_name = :positions_in_markerspace,
        input_space = :space, output_space = :markerspace, apply_clip_planes = false
    )
    map!(cairo_scatter_marker, attr, :marker, :cairo_marker)
    size_model!(attr)
    if !haskey(attr, :eye_to_clip)
        add_input!(attr, :eye_to_clip, scene.compute.projection)
        add_input!(attr, :cam_view, scene.compute.view) # different from plot.view
    end
    inputs = [
        :positions_in_markerspace, :projectionview, :eye_to_clip, :cam_view,
        :markersize, :strokewidth, :cairo_marker, :marker_offset,
        :converted_rotation, :billboard, :transform_marker, :size_model, :markerspace,
        :space, :clip_planes, :unclipped_indices, :font,
        :strokecolor, :computed_color, :resolution,
    ]
    extract_attributes!(attr, inputs, :cairo_attributes)
    ctx = screen.context
    return draw_atomic_scatter(ctx, attr[:cairo_attributes][])
end

function draw_atomic(scene::Scene, screen::Screen, plot::Text)
    # :text_strokewidth # TODO: missing, but does per-glyph strokewidth even work? Same for strokecolor?
    attr = plot.attributes
    # input -> markerspace
    # TODO: We're doing per-string/glyphcollection work per glyph here
    cairo_unclipped_indices!(attr, :per_char_positions_transformed_f32c)
    Makie.register_positions_projected!(
        scene.compute, attr, Point3d;
        input_name = :positions_transformed_f32c, output_name = :positions_in_markerspace,
        input_space = :space, output_space = :markerspace, apply_clip_planes = false
    )
    Makie.add_computation!(attr, scene, Val(:meshscatter_f32c_scale))
    size_model!(attr)
    if !haskey(attr, :eye_to_clip)
        add_input!(attr, :eye_to_clip, scene.compute.projection)
        add_input!(attr, :cam_view, scene.compute.view) # different from plot.view
    end
    inputs = [
        :text_blocks, :font_per_char, :glyphindices, :marker_offset, :text_rotation,
        :text_scales, :text_strokewidth, :text_strokecolor, :markerspace,
        :text_color, :glowwidth, :glowcolor,
        :positions_in_markerspace, :projectionview, :eye_to_clip, :cam_view, :resolution,
        :transform_marker, :size_model, :unclipped_indices,
    ]
    extract_attributes!(attr, inputs, :cairo_attributes)
    ctx = screen.context
    return draw_text(ctx, attr[:cairo_attributes][])
end


function draw_atomic_scatter(ctx, attr::NamedTuple)
    size_model = attr.size_model
    font = attr.font
    markerspace = attr.markerspace
    billboard = attr.billboard
    cam = (
        resolution = attr.resolution,
        projectionview = attr.projectionview,
        eye_to_clip = attr.eye_to_clip,
        view = attr.cam_view,
    )
    args = (
        attr.unclipped_indices,
        attr.positions_in_markerspace,
        attr.computed_color,
        attr.markersize,
        attr.strokecolor,
        attr.strokewidth,
        attr.cairo_marker,
        attr.marker_offset,
        attr.converted_rotation,
    )

    Makie.broadcast_foreach_index(args...) do position, col, markersize, strokecolor, strokewidth, marker, marker_offset, rot
        isnan(position) && return
        isnan(rot) && return # matches GLMakie
        (isnan(markersize) || is_approx_zero(markersize)) && return
        rotation = remove_billboard(rot)
        origin = position .+ size_model * to_ndim(Vec3d, marker_offset, 0)

        proj_pos, mat, jl_mat = project_marker(
            cam, markerspace, origin, markersize, rotation, size_model, billboard
        )

        # mat and jl_mat are the same matrix, once as a CairoMatrix, once as a Mat2f
        # They both describe an approximate basis transformation matrix from
        # marker space to pixel space with scaling appropriate to markersize.
        # Markers that can be drawn from points/vertices of shape (e.g. Rect)
        # could be projected more accurately by projecting each point individually
        # and then building the shape.

        # make sure the matrix is not degenerate
        is_degenerate(jl_mat) && return

        Cairo.set_source_rgba(ctx, rgbatuple(col)...)
        Cairo.save(ctx)
        if marker isa Char
            draw_marker(ctx, marker, best_font(marker, font), proj_pos, strokecolor, strokewidth, jl_mat, mat)
        else
            draw_marker(ctx, marker, proj_pos, strokecolor, strokewidth, mat)
        end
        Cairo.restore(ctx)
    end
    return
end

function flush_glyph_batch!(ctx, glyph_buffer, font, color, mat, strokewidth, strokecolor)
    isempty(glyph_buffer) && return

    cairoface = set_ft_font(ctx, font)
    old_matrix = get_font_matrix(ctx)

    Cairo.save(ctx)
    Cairo.set_source_rgba(ctx, rgbatuple(color)...)
    set_font_matrix(ctx, mat)
    show_glyphs(ctx, glyph_buffer)
    Cairo.restore(ctx)

    if strokewidth > 0 && strokecolor != RGBAf(0, 0, 0, 0)
        Cairo.save(ctx)
        set_font_matrix(ctx, mat)
        glyphs_path(ctx, glyph_buffer)
        Cairo.set_source_rgba(ctx, rgbatuple(strokecolor)...)
        Cairo.set_line_width(ctx, strokewidth)
        Cairo.stroke(ctx)
        Cairo.restore(ctx)
    end

    cairo_font_face_destroy(cairoface)
    set_font_matrix(ctx, old_matrix)
    empty!(glyph_buffer)
    return
end

function draw_text(ctx, attr::NamedTuple)
    positions = attr.positions_in_markerspace
    text_blocks = attr.text_blocks
    font_per_char = attr.font_per_char
    glyphindices = attr.glyphindices
    marker_offset = attr.marker_offset
    text_rotation = attr.text_rotation
    text_scales = attr.text_scales
    text_strokewidth = attr.text_strokewidth
    text_strokecolor = attr.text_strokecolor
    text_color = attr.text_color
    markerspace = attr.markerspace
    valid_indices = attr.unclipped_indices
    glowwidth = attr.glowwidth
    glowcolor = attr.glowcolor
    glow_r, glow_g, glow_b, glow_a = rgbatuple(glowcolor)
    size_model = attr.size_model
    cam = (
        resolution = attr.resolution,
        projectionview = attr.projectionview,
        eye_to_clip = attr.eye_to_clip,
        view = attr.cam_view,
    )

    glyph_buffer = CairoGlyph[]

    for (block_idx, glyph_indices) in enumerate(text_blocks)
        Cairo.save(ctx)

        glyph_pos = positions[block_idx]
        local batch_font, batch_color, batch_mat, batch_strokewidth, batch_strokecolor

        # Glow pass: build combined glyph path once, stroke with decreasing widths
        if glowwidth > 0 && glow_a > 0
            Cairo.save(ctx)
            for glyph_idx in glyph_indices
                glyph_idx in valid_indices || continue
                glyph = glyphindices[glyph_idx]
                glyph == 0 && continue
                gp3 = glyph_pos .+ size_model * marker_offset[glyph_idx]
                any(isnan, gp3) && continue
                scale = Makie.sv_getindex(text_scales, glyph_idx)
                rotation = Makie.sv_getindex(text_rotation, glyph_idx)
                pos, mat, _ = project_marker(cam, markerspace, Point3d(gp3), scale, rotation, size_model)
                cairoface = set_ft_font(ctx, font_per_char[glyph_idx])
                set_font_matrix(ctx, mat)
                glyph_path(ctx, glyph, pos...)
                cairo_font_face_destroy(cairoface)
            end
            n_layers = max(1, round(Int, glowwidth))
            Cairo.set_source_rgba(ctx, glow_r, glow_g, glow_b, glow_a / n_layers)
            Cairo.set_line_join(ctx, Cairo.CAIRO_LINE_JOIN_ROUND)
            Cairo.set_line_cap(ctx, Cairo.CAIRO_LINE_CAP_ROUND)
            for i in n_layers:-1:2
                Cairo.set_line_width(ctx, 2.0 * glowwidth * i / n_layers)
                Cairo.stroke_preserve(ctx)
            end
            Cairo.set_line_width(ctx, 2.0 * glowwidth / n_layers)
            Cairo.stroke(ctx)
            Cairo.restore(ctx)
        end

        for glyph_idx in glyph_indices
            glyph_idx in valid_indices || continue

            glyph = glyphindices[glyph_idx]
            glyph == 0 && continue

            offset = marker_offset[glyph_idx]
            font = font_per_char[glyph_idx]
            rotation = Makie.sv_getindex(text_rotation, glyph_idx)
            color = Makie.sv_getindex(text_color, glyph_idx)
            strokewidth = Makie.sv_getindex(text_strokewidth, glyph_idx)
            strokecolor = Makie.sv_getindex(text_strokecolor, glyph_idx)
            scale = Makie.sv_getindex(text_scales, glyph_idx)

            gp3 = glyph_pos .+ size_model * offset
            any(isnan, gp3) && continue

            glyphpos, mat, _ = project_marker(cam, markerspace, Point3d(gp3), scale, rotation, size_model)

            if !isempty(glyph_buffer) && (
                    font !== batch_font ||
                        color != batch_color ||
                        mat != batch_mat ||
                        strokewidth != batch_strokewidth ||
                        strokecolor != batch_strokecolor
                )
                flush_glyph_batch!(ctx, glyph_buffer, batch_font, batch_color, batch_mat, batch_strokewidth, batch_strokecolor)
            end

            if isempty(glyph_buffer)
                batch_font = font
                batch_color = color
                batch_mat = mat
                batch_strokewidth = strokewidth
                batch_strokecolor = strokecolor
            end

            push!(glyph_buffer, CairoGlyph(glyph, glyphpos[1], glyphpos[2]))
        end

        if !isempty(glyph_buffer)
            flush_glyph_batch!(ctx, glyph_buffer, batch_font, batch_color, batch_mat, batch_strokewidth, batch_strokecolor)
        end
        Cairo.restore(ctx)
    end
    return
end

function cairo_unclipped_indices!(attr::Makie.ComputeGraph, position_name = :positions_transformed_f32c)
    return Makie.register_computation!(
        attr,
        [position_name, :model_f32c, :space, :clip_planes],
        [:unclipped_indices]
    ) do (transformed, model, space, clip_planes), changed, outputs
        return (unclipped_indices(to_model_space(model, clip_planes), transformed, space),)
    end
end

function size_model!(attr)
    return map!(attr, [:f32c_scale, :model, :markerspace, :transform_marker], :size_model) do f32c_scale, model, markerspace, transform_marker
        size_model = transform_marker ? model[Vec(1, 2, 3), Vec(1, 2, 3)] : Mat3d(I)
        return Mat3d(f32c_scale[1], 0, 0, 0, f32c_scale[2], 0, 0, 0, f32c_scale[3]) * size_model
    end
end


function project_marker(cam, markerspace::Symbol, origin::Point3, scale::Vec, rotation, model33::Mat3, billboard = false)
    # the CairoMatrix is found by transforming the right and up vector
    # of the marker into screen space and then subtracting the projected
    # origin. The resulting vectors give the directions in which the character
    # needs to be stretched in order to match the 3D projection

    xvec = rotation * (model33 * (scale[1] * Point3d(1, 0, 0)))
    yvec = rotation * (model33 * (scale[2] * Point3d(0, -1, 0)))
    pv = cam.projectionview
    resolution = cam.resolution
    proj_pos = project_flipped(pv, resolution, origin, true)
    if billboard && Makie.is_data_space(markerspace)
        p4d = cam.view * to_ndim(Point4d, origin, 1)
        p4d_clip = p4d[Vec(1, 2, 3)] / p4d[4]
        xproj = project_flipped(cam.eye_to_clip, resolution, p4d_clip + xvec, true)
        yproj = project_flipped(cam.eye_to_clip, resolution, p4d_clip + yvec, true)
    else
        xproj = project_flipped(pv, resolution, origin + xvec, true)
        yproj = project_flipped(pv, resolution, origin + yvec, true)
    end

    # CairoMatrix somehow has a bug if the precision is too high
    # Where in rare cases a glyph becomes suddenly really large
    xdiff = xproj - proj_pos
    ydiff = yproj - proj_pos

    mat = Cairo.CairoMatrix(
        xdiff[1], xdiff[2],
        ydiff[1], ydiff[2],
        0, 0,
    )

    return proj_pos, mat, Mat2f(xdiff..., ydiff...)
end

function project_flipped(trans::Mat4, res, point::Union{Point3, Vec3}, yflip::Bool)
    p4d = to_ndim(Vec4d, to_ndim(Vec3d, point, 0.0), 1.0)
    clip = trans * p4d
    # between -1 and 1
    p = clip[Vec(1, 2)] ./ clip[4]
    # flip y to match cairo
    p_yflip = Vec2d(p[1], (1.0 - 2.0 * yflip) * p[2])
    # normalize to between 0 and 1
    p_0_to_1 = (p_yflip .+ 1.0) ./ 2.0
    # multiply with scene resolution for final position
    return p_0_to_1 .* res
end

function draw_marker(ctx, marker::Char, font, pos, strokecolor, strokewidth, jl_mat, mat)
    cairoface = set_ft_font(ctx, font)

    # The given pos includes the user position which corresponds to the center
    # of the marker and the user marker_offset which may shift the position.
    # At this point we still need to center the character we draw. For that we
    # get the character boundingbox where (0,0) is the anchor point:
    charextent = Makie.FreeTypeAbstraction.get_extent(font, marker)
    inkbb = Makie.FreeTypeAbstraction.inkboundingbox(charextent)

    # And calculate an offset to the the center of the marker
    centering_offset = Makie.origin(inkbb) .+ 0.5f0 .* widths(inkbb)
    # which we then transform from marker space to screen space using the
    # local coordinate transform derived by project_marker()
    # (Need yflip because Cairo's y coordinates are reversed)
    char_offset = Vec2f(jl_mat * ((1, -1) .* centering_offset))

    # The offset is then applied to pos and the marker placement is set
    charorigin = pos - char_offset
    Cairo.translate(ctx, charorigin[1], charorigin[2])

    # The font matrix takes care of rotation, scaling and shearing of the marker
    old_matrix = get_font_matrix(ctx)
    set_font_matrix(ctx, mat)

    Cairo.move_to(ctx, 0, 0)
    Cairo.text_path(ctx, string(marker))
    Cairo.fill_preserve(ctx)
    # stroke
    Cairo.set_line_width(ctx, strokewidth)
    Cairo.set_source_rgba(ctx, rgbatuple(strokecolor)...)
    Cairo.stroke(ctx)

    # if we use set_ft_font we should destroy the pointer it returns
    cairo_font_face_destroy(cairoface)

    set_font_matrix(ctx, old_matrix)
    return
end

function draw_marker(ctx, ::Type{<:Circle}, pos, strokecolor, strokewidth, mat)
    # There are already active transforms so we can't Cairo.set_matrix() here
    Cairo.translate(ctx, pos[1], pos[2])
    cairo_transform(ctx, mat)
    Cairo.arc(ctx, 0, 0, 0.5, 0, 2 * pi)
    Cairo.fill_preserve(ctx)
    Cairo.set_line_width(ctx, Float64(strokewidth))
    sc = to_color(strokecolor)
    Cairo.set_source_rgba(ctx, rgbatuple(sc)...)
    Cairo.stroke(ctx)
    return
end

function draw_marker(ctx, ::Union{Makie.FastPixel, <:Type{<:Rect}}, pos, strokecolor, strokewidth, mat)
    # There are already active transforms so we can't Cairo.set_matrix() here
    Cairo.translate(ctx, pos[1], pos[2])
    cairo_transform(ctx, mat)
    Cairo.rectangle(ctx, -0.5, -0.5, 1, 1)
    Cairo.fill_preserve(ctx)
    Cairo.set_line_width(ctx, Float64(strokewidth))
    sc = to_color(strokecolor)
    Cairo.set_source_rgba(ctx, rgbatuple(sc)...)
    Cairo.stroke(ctx)
    return
end

function draw_marker(ctx, beziermarker::BezierPath, pos, strokecolor, strokewidth, mat)
    Cairo.save(ctx)
    # There are already active transforms so we can't Cairo.set_matrix() here
    Cairo.translate(ctx, pos[1], pos[2])
    cairo_transform(ctx, mat)
    Cairo.scale(ctx, 1, -1) # maybe to transition BezierPath y to Cairo y?
    draw_path(ctx, beziermarker)
    Cairo.fill_preserve(ctx)
    sc = to_color(strokecolor)
    Cairo.set_source_rgba(ctx, rgbatuple(sc)...)
    Cairo.set_line_width(ctx, Float64(strokewidth))
    Cairo.stroke(ctx)
    Cairo.restore(ctx)
    return
end

function draw_path(ctx, bp::BezierPath)
    for i in eachindex(bp.commands)
        @inbounds command = bp.commands[i]
        if command isa MoveTo
            path_command(ctx, command)
        elseif command isa LineTo
            path_command(ctx, command)
        elseif command isa CurveTo
            path_command(ctx, command)
        elseif command isa ClosePath
            path_command(ctx, command)
        elseif command isa EllipticalArc
            path_command(ctx, command)
        end
    end
    return
end
path_command(ctx, c::MoveTo) = Cairo.move_to(ctx, c.p...)
path_command(ctx, c::LineTo) = Cairo.line_to(ctx, c.p...)
path_command(ctx, c::CurveTo) = Cairo.curve_to(ctx, c.c1..., c.c2..., c.p...)
path_command(ctx, ::ClosePath) = Cairo.close_path(ctx)
function path_command(ctx, c::EllipticalArc)
    Cairo.save(ctx)
    Cairo.translate(ctx, c.c...)
    Cairo.rotate(ctx, c.angle)
    Cairo.scale(ctx, 1, c.r2 / c.r1)
    if c.a2 > c.a1
        Cairo.arc(ctx, 0, 0, c.r1, c.a1, c.a2)
    else
        Cairo.arc_negative(ctx, 0, 0, c.r1, c.a1, c.a2)
    end
    return Cairo.restore(ctx)
end


function draw_marker(
        ctx, marker::Matrix{T}, pos,
        strokecolor #= unused =#, strokewidth #= unused =#,
        mat
    ) where {T <: Colorant}

    # convert marker to Cairo compatible image data
    marker = permutedims(marker, (2, 1))
    marker_surf = to_cairo_image(marker)

    w, h = size(marker)

    # There are already active transforms so we can't Cairo.set_matrix() here
    Cairo.translate(ctx, pos[1], pos[2])
    cairo_transform(ctx, mat)
    Cairo.scale(ctx, 1.0 / w, 1.0 / h)
    Cairo.set_source_surface(ctx, marker_surf, -w / 2, -h / 2)
    Cairo.paint(ctx)
    return
end

module CairoMakie

using Makie.ComputePipeline
using Makie, LinearAlgebra
using Colors, GeometryBasics, FileIO
import CRC32c
import Cairo

using Makie: Scene, Lines, Text, Image, Heatmap, Scatter, @key_str, broadcast_foreach
using Makie: convert_attribute, @extractvalue, LineSegments, to_ndim, NativeFont
using Makie: @info, @get_attribute, Plot, MakieScreen
using Makie: to_value, to_colormap, extrema_nan
using Makie.Observables
using Makie: spaces, is_data_space, is_pixel_space, is_relative_space, is_clip_space
using Makie: numbers_to_colors
using Makie: Mat3f, Mat4f, Mat3d, Mat4d
using Makie: sv_getindex
using Makie: compute_colors

# re-export Makie, including deprecated names
for name in names(Makie, all = true)
    if Base.isexported(Makie, name)
        @eval using Makie: $(name)
        @eval export $(name)
    end
end

include("cairo-extension.jl")
include("screen.jl")
include("display.jl")
include("plot-primitives.jl")
include("utils.jl")
include("lines.jl")
include("scatter.jl")
include("image-hmap.jl")
include("mesh.jl")
include("overrides.jl")

function __init__()
    return activate!()
end

include("precompiles.jl")

end

using Base.Docs: doc

@enum RenderType SVG IMAGE PDF EPS HTML

Base.convert(::Type{RenderType}, ::MIME{SYM}) where {SYM} = mime_to_rendertype(SYM)
function Base.convert(::Type{RenderType}, type::String)
    if type == "png"
        return IMAGE
    elseif type == "svg"
        return SVG
    elseif type == "pdf"
        return PDF
    elseif type == "eps"
        return EPS
    elseif type in ("html", "text/html", "application/vnd.webio.application+html", "application/prs.juno.plotpane+html", "juliavscode/html")
        return HTML
    else
        error("Unsupported cairo render type: $type")
    end
end

"Convert a rendering type to a MIME type"
function to_mime(type::RenderType)
    type == SVG && return MIME("image/svg+xml")
    type == PDF && return MIME("application/pdf")
    type == EPS && return MIME("application/postscript")
    type == HTML && return MIME("text/html")
    return MIME("image/png")
end

"convert a mime to a RenderType"
function mime_to_rendertype(mime::Symbol)::RenderType
    if mime == Symbol("image/png")
        return IMAGE
    elseif mime == Symbol("image/svg+xml")
        return SVG
    elseif mime == Symbol("application/pdf")
        return PDF
    elseif mime == Symbol("application/postscript")
        return EPS
    elseif mime in (Symbol("text/html"), Symbol("text/html"), Symbol("application/vnd.webio.application+html"), Symbol("application/prs.juno.plotpane+html"), Symbol("juliavscode/html"))
        return HTML
    else
        error("Unsupported mime: $mime")
    end
end

function surface_from_output_type(mime::MIME{M}, io, w, h) where {M}
    return surface_from_output_type(M, io, w, h)
end

function surface_from_output_type(mime::Symbol, io, w, h)
    return surface_from_output_type(mime_to_rendertype(mime), io, w, h)
end

function surface_from_output_type(type::RenderType, io, w, h)
    if type === SVG
        return Cairo.CairoSVGSurface(io, w, h)
    elseif type === PDF
        return Cairo.CairoPDFSurface(io, w, h)
    elseif type === EPS
        return Cairo.CairoEPSSurface(io, w, h)
    elseif type === IMAGE || type === HTML
        img = fill(ARGB32(0, 0, 0, 0), w, h)
        return Cairo.CairoImageSurface(img)
    else
        error("No available Cairo surface for mode $type")
    end
end

@enum PDFVersion PDFv14 PDFv15 PDFv16 PDFv17
function pdfversion(version::AbstractString)
    version == "1.4" && return PDFv14
    version == "1.5" && return PDFv15
    version == "1.6" && return PDFv16
    version == "1.7" && return PDFv17
    throw(ArgumentError("PDF version must be one of '1.4', '1.5', '1.6', '1.7' (received '$version')"))
end

"""
Supported options: `[:best => Cairo.ANTIALIAS_BEST, :good => Cairo.ANTIALIAS_GOOD, :subpixel => Cairo.ANTIALIAS_SUBPIXEL, :none => Cairo.ANTIALIAS_NONE]`
"""
function to_cairo_antialias(sym::Symbol)
    sym === :best && return Cairo.ANTIALIAS_BEST
    sym === :good && return Cairo.ANTIALIAS_GOOD
    sym === :subpixel && return Cairo.ANTIALIAS_SUBPIXEL
    sym === :none && return Cairo.ANTIALIAS_NONE
    error("Wrong antialias setting: $(sym). Allowed: :best, :good, :subpixel, :none")
end
to_cairo_antialias(aa::Int) = aa

"""
* `px_per_unit = 2.0`
* `pt_per_unit = 0.75`
* `antialias::Union{Symbol, Int} = :best`: antialias modus Cairo uses to draw. Applicable options: `[:best => Cairo.ANTIALIAS_BEST, :good => Cairo.ANTIALIAS_GOOD, :subpixel => Cairo.ANTIALIAS_SUBPIXEL, :none => Cairo.ANTIALIAS_NONE]`.
* `visible::Bool`: if true, a browser/image viewer will open to display rendered output.
* `pdf_version::String = nothing`: the version of output PDFs. Applicable options are `"1.4"`, `"1.5"`, `"1.6"`, `"1.7"`, or `nothing`, which leaves the PDF version unrestricted.
"""
struct ScreenConfig
    px_per_unit::Float64
    pt_per_unit::Float64
    antialias::Symbol
    visible::Bool
    start_renderloop::Bool # Only used to satisfy the interface for record using `Screen(...; start_renderloop=false)` for GLMakie
    pdf_version::Union{Nothing, PDFVersion}

    function ScreenConfig(
            px_per_unit::Real, pt_per_unit::Real,
            antialias::Symbol, visible::Bool, start_renderloop::Bool,
            pdf_version::Union{Nothing, AbstractString}
        )
        v = isnothing(pdf_version) ? nothing : pdfversion(pdf_version)
        return new(px_per_unit, pt_per_unit, antialias, visible, start_renderloop, v)
    end
end

css_px_per_unit(pt_per_unit) = pt_per_unit / 0.75

function device_scaling_factor(rendertype, sc::ScreenConfig)
    rt = convert(RenderType, rendertype)
    isv = is_vector_backend(rt)
    # from version 1.18 on, Cairo saves SVGs without the pt unit specified, so they are actually in CSS px now
    return rt === SVG ? css_px_per_unit(sc.pt_per_unit) : isv ? sc.pt_per_unit : sc.px_per_unit
end

function device_scaling_factor(surface::Cairo.CairoSurface, sc::ScreenConfig)
    return device_scaling_factor(get_render_type(surface), sc)
end

const LAST_INLINE = Ref{Union{Makie.Automatic, Bool}}(Makie.automatic)

"""
    CairoMakie.activate!(; screen_config...)

Sets CairoMakie as the currently active backend and also allows to quickly set the `screen_config`.
Note, that the `screen_config` can also be set permanently via `Makie.set_theme!(CairoMakie=(screen_config...,))`.

# Arguments one can pass via `screen_config`:

$(Base.doc(ScreenConfig))
"""
function activate!(; inline = LAST_INLINE[], type = "png", screen_config...)
    Makie.inline!(inline)
    LAST_INLINE[] = inline
    Makie.set_screen_config!(CairoMakie, screen_config)
    if type == "png"
        # So this is a bit counter intuitive, since the display system doesn't let us prefer a mime.
        # Instead, any IDE with rich output usually has a priority list of mimes, which it iterates to figure out the best mime.
        # So, if we want to prefer the png mime, we disable the mimes that are usually higher up in the stack.
        disable_mime!("svg", "pdf")
    elseif type == "svg"
        disable_mime!("text/html", "application/vnd.webio.application+html", "application/prs.juno.plotpane+html", "juliavscode/html")
    else
        enable_only_mime!(type)
    end

    Makie.set_active_backend!(CairoMakie)
    return
end

"""
    Screen(; screen_config...)

# Arguments one can pass via `screen_config`:

$(Base.doc(ScreenConfig))

# Constructors:

$(Base.doc(MakieScreen))
"""
mutable struct Screen{SurfaceRenderType} <: Makie.MakieScreen
    scene::Scene
    surface::Cairo.CairoSurface
    context::Cairo.CairoContext
    device_scaling_factor::Float64
    antialias::Int # cairo_antialias_t
    visible::Bool
    config::ScreenConfig

    function Screen()
        return new{IMAGE}()
    end
    function Screen{SurfaceRenderType}(
            scene::Scene,
            surface::Cairo.CairoSurface,
            context::Cairo.CairoContext,
            device_scaling_factor::Float64,
            antialias::Int,
            visible::Bool,
            config::ScreenConfig
        ) where {SurfaceRenderType}

        return new{SurfaceRenderType}(
            scene,
            surface,
            context,
            device_scaling_factor,
            antialias,
            visible,
            config,
        )
    end

end

function Base.empty!(screen::Screen)
    isopen(screen) || return
    ctx = screen.context
    Cairo.save(ctx)
    bg = rgbatuple(screen.scene.backgroundcolor[])
    Cairo.set_source_rgba(ctx, bg...)
    Cairo.set_operator(ctx, Cairo.OPERATOR_CLEAR)
    Cairo.rectangle(ctx, 0, 0, size(screen)...)
    Cairo.paint_with_alpha(ctx, 1.0)
    return Cairo.restore(ctx)
end

Base.close(screen::Screen) = empty!(screen)

function destroy!(screen::Screen)
    isdefined(screen, :surface) || return
    Cairo.destroy(screen.surface)
    return Cairo.destroy(screen.context)
end

function Base.isopen(screen::Screen)
    return !(screen.surface.ptr == C_NULL || screen.context.ptr == C_NULL)
end

function Base.size(screen::Screen)
    isdefined(screen, :surface) || return (0, 0)
    return round.(Int, (screen.surface.width, screen.surface.height))
end
# we render the scene directly, since we have
# no screen dependent state like in e.g. opengl
Base.insert!(screen::Screen, scene::Scene, plot) = nothing

function Base.delete!(screen::Screen, scene::Scene, plot::AbstractPlot)
    # Currently, we rerender every time, so nothing needs
    # to happen here.  However, in the event that changes,
    # e.g. if we integrate a Gtk window, we may need to
    # do something here.
end

function Base.show(io::IO, ::MIME"text/plain", screen::Screen{S}) where {S}
    return println(io, "CairoMakie.Screen{$S}")
end

function path_to_type(path)
    type = splitext(path)[2][2:end]
    return convert(RenderType, type)
end
to_mime(screen::Screen) = to_mime(screen.typ)


########################################
#    Constructor                       #
########################################

function apply_config!(screen::Screen, config::ScreenConfig)
    empty!(screen)
    surface = screen.surface
    context = screen.context
    dsf = device_scaling_factor(surface, config)
    surface_set_device_scale(surface, dsf)
    aa = to_cairo_antialias(config.antialias)
    Cairo.set_antialias(context, aa)
    set_miter_limit(context, 2.0)

    if get_render_type(surface) === PDF && !isnothing(config.pdf_version)
        restrict_pdf_version!(surface, Int(config.pdf_version))
    end

    screen.antialias = aa
    screen.device_scaling_factor = dsf
    screen.config = config
    return screen
end

function scaled_scene_resolution(typ::RenderType, config::ScreenConfig, scene::Scene)
    dsf = device_scaling_factor(typ, config)
    return round.(Int, size(scene) .* dsf)
end

function Makie.apply_screen_config!(
        screen::Screen{SCREEN_RT}, config::ScreenConfig, scene::Scene, io::Union{Nothing, IO}, m::MIME{SYM}
    ) where {SYM, SCREEN_RT}
    # the surface size is the scene size scaled by the device scaling factor
    new_rendertype = mime_to_rendertype(SYM)
    # we need to re-create the screen if the rendertype changes, or for all vector backends
    # since they need to use the new IO, or if the resolution changed!
    new_resolution = scaled_scene_resolution(new_rendertype, config, scene)
    if SCREEN_RT !== new_rendertype || is_vector_backend(new_rendertype) || size(screen) != new_resolution
        old_screen = screen
        surface = surface_from_output_type(new_rendertype, io, new_resolution...)
        screen = Screen(scene, config, surface)
        @assert new_resolution == size(screen)
        destroy!(old_screen)
    end
    apply_config!(screen, config)
    screen.scene = scene
    return screen
end

function Makie.apply_screen_config!(screen::Screen, config::ScreenConfig, scene::Scene, args...)
    # No mime as an argument implies we want an image based surface
    return Makie.apply_screen_config!(screen, config, scene, nothing, MIME"image/png"())
end

function Makie.px_per_unit(s::Screen)::Float64
    return s.config.px_per_unit
end

function Screen(scene::Scene; screen_config...)
    config = Makie.merge_screen_config(ScreenConfig, Dict{Symbol, Any}(screen_config))
    return Screen(scene, config)
end

Screen(scene::Scene, config::ScreenConfig) = Screen(scene, config, nothing, IMAGE)

function Screen(screen::Screen, io_or_path::Union{Nothing, String, IO}, typ::Union{MIME, Symbol, RenderType})
    rtype = convert(RenderType, typ)
    # the resolution may change between rendertypes, so, we can't just use `size(screen)` here for recreating the Screen:
    w, h = scaled_scene_resolution(rtype, screen.config, screen.scene)
    surface = surface_from_output_type(rtype, io_or_path, w, h)
    return Screen(screen.scene, screen.config, surface)
end

function Screen(scene::Scene, config::ScreenConfig, io_or_path::Union{Nothing, String, IO}, typ::Union{MIME, Symbol, RenderType})
    rtype = convert(RenderType, typ)
    w, h = scaled_scene_resolution(rtype, config, scene)
    surface = surface_from_output_type(rtype, io_or_path, w, h)
    return Screen(scene, config, surface)
end

function Screen(scene::Scene, config::ScreenConfig, ::Makie.ImageStorageFormat)
    w, h = scaled_scene_resolution(IMAGE, config, scene)
    # create an image surface to draw onto the image
    img = fill(ARGB32(0, 0, 0, 0), w, h)
    surface = Cairo.CairoImageSurface(img)
    return Screen(scene, config, surface)
end

function Screen(scene::Scene, config::ScreenConfig, surface::Cairo.CairoSurface)
    # the surface size is the scene size scaled by the device scaling factor
    dsf = device_scaling_factor(surface, config)
    surface_set_device_scale(surface, dsf)
    ctx = Cairo.CairoContext(surface)
    aa = to_cairo_antialias(config.antialias)
    Cairo.set_antialias(ctx, aa)
    set_miter_limit(ctx, 2.0)

    if get_render_type(surface) === PDF && !isnothing(config.pdf_version)
        restrict_pdf_version!(surface, Int(config.pdf_version))
    end

    return Screen{get_render_type(surface)}(scene, surface, ctx, dsf, aa, config.visible, config)
end

########################################
#    Fast colorbuffer for recording    #
########################################

function Makie.colorbuffer(screen::Screen; figure = nothing)
    # extract scene
    scene = screen.scene
    # get resolution
    w, h = size(screen)
    # preallocate an image matrix
    img = fill(ARGB32(0, 0, 0, 0), w, h)
    # create an image surface to draw onto the image
    surf = Cairo.CairoImageSurface(img)
    s = Screen(scene, screen.config, surf)
    return Makie.colorbuffer(s)
end

function Makie.colorbuffer(screen::Screen{IMAGE}; figure = nothing)
    Makie.push_screen!(screen.scene, screen)
    empty!(screen)
    cairo_draw(screen, screen.scene)
    return PermutedDimsArray(screen.surface.data, (2, 1))
end

is_vector_backend(ctx::Cairo.CairoContext) = is_vector_backend(ctx.surface)
is_vector_backend(surf::Cairo.CairoSurface) = is_vector_backend(get_render_type(surf))
is_vector_backend(rt::RenderType) = rt in (PDF, EPS, SVG)

# no need for resizing screen, since we need to redisplay anyways!
Base.resize!(screen::Screen, w, h) = nothing

# TODO, move those to Cairo?

function set_font_matrix(ctx, matrix)
    return ccall((:cairo_set_font_matrix, Cairo.libcairo), Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), ctx.ptr, Ref(matrix))
end

function get_font_matrix(ctx)
    matrix = Ref(Cairo.CairoMatrix())
    ccall((:cairo_get_font_matrix, Cairo.libcairo), Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), ctx.ptr, matrix)
    return matrix[]
end

function pattern_set_matrix(ctx, matrix)
    return ccall((:cairo_pattern_set_matrix, Cairo.libcairo), Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), ctx.ptr, Ref(matrix))
end

function pattern_get_matrix(ctx)
    matrix = Ref(Cairo.CairoMatrix())
    ccall((:cairo_pattern_get_matrix, Cairo.libcairo), Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), ctx.ptr, matrix)
    return matrix[]
end

function cairo_font_face_destroy(font_face)
    return ccall(
        (:cairo_font_face_destroy, Cairo.libcairo),
        Cvoid, (Ptr{Cvoid},),
        font_face
    )
end

function cairo_transform(ctx, cairo_matrix)
    return ccall(
        (:cairo_transform, Cairo.libcairo),
        Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}),
        ctx.ptr, Ref(cairo_matrix)
    )
end

function set_ft_font(ctx, font)

    font_face = Base.@lock font.lock ccall(
        (:cairo_ft_font_face_create_for_ft_face, Cairo.libcairo),
        Ptr{Cvoid}, (Makie.FreeTypeAbstraction.FT_Face, Cint),
        font, 0
    )
    ccall((:cairo_set_font_face, Cairo.libcairo), Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), ctx.ptr, font_face)

    return font_face
end

struct CairoGlyph
    index::Culong
    x::Cdouble
    y::Cdouble
end

function show_glyph(ctx, glyph, x, y)
    cg = Ref(CairoGlyph(glyph, x, y))
    return ccall(
        (:cairo_show_glyphs, Cairo.libcairo),
        Nothing, (Ptr{Nothing}, Ptr{CairoGlyph}, Cint),
        ctx.ptr, cg, 1
    )
end

function show_glyphs(ctx, glyphs::Vector{CairoGlyph})
    return ccall(
        (:cairo_show_glyphs, Cairo.libcairo),
        Nothing, (Ptr{Nothing}, Ptr{CairoGlyph}, Cint),
        ctx.ptr, glyphs, length(glyphs)
    )
end

function glyph_path(ctx, glyph, x, y)
    cg = Ref(CairoGlyph(glyph, x, y))
    return ccall(
        (:cairo_glyph_path, Cairo.libcairo),
        Nothing, (Ptr{Nothing}, Ptr{CairoGlyph}, Cint),
        ctx.ptr, cg, 1
    )
end

function glyphs_path(ctx, glyphs::Vector{CairoGlyph})
    return ccall(
        (:cairo_glyph_path, Cairo.libcairo),
        Nothing, (Ptr{Nothing}, Ptr{CairoGlyph}, Cint),
        ctx.ptr, glyphs, length(glyphs)
    )
end

function surface_get_device_scale(surf)
    x = Ref(0.0)
    y = Ref(0.0)
    ccall(
        (:cairo_surface_get_device_scale, Cairo.libcairo),
        Cvoid, (Ptr{Nothing}, Ptr{Nothing}, Ptr{Nothing}),
        surf.ptr, x, y
    )
    return x[], y[]
end

function surface_set_device_scale(surf, device_x_scale, device_y_scale = device_x_scale)
    # this sets a scaling factor on the lowest level that is "hidden" so its even
    # enabled when the drawing space is reset for strokes
    # that means it can be used to increase or decrease the image resolution

    # This call becomes increasingly expensive for some reason
    old_x_scale, old_y_scale = surface_get_device_scale(surf)
    if old_x_scale != device_x_scale || old_y_scale != device_y_scale
        ccall(
            (:cairo_surface_set_device_scale, Cairo.libcairo),
            Cvoid, (Ptr{Nothing}, Cdouble, Cdouble),
            surf.ptr, device_x_scale, device_y_scale
        )
    end
    return
end

function set_miter_limit(ctx, limit)
    return ccall((:cairo_set_miter_limit, Cairo.libcairo), Cvoid, (Ptr{Nothing}, Cdouble), ctx.ptr, limit)
end

function get_render_type(surface::Cairo.CairoSurface)
    @assert surface.ptr != C_NULL
    typ = ccall((:cairo_surface_get_type, Cairo.libcairo), Cint, (Ptr{Nothing},), surface.ptr)
    typ == Cairo.CAIRO_SURFACE_TYPE_PDF && return PDF
    typ == Cairo.CAIRO_SURFACE_TYPE_PS && return EPS
    typ == Cairo.CAIRO_SURFACE_TYPE_SVG && return SVG
    typ == Cairo.CAIRO_SURFACE_TYPE_IMAGE && return IMAGE
    return IMAGE # By default assume that the render type is IMAGE
end

function restrict_pdf_version!(surface::Cairo.CairoSurface, v::Integer)
    @assert surface.ptr != C_NULL
    0 ≤ v ≤ 3 || throw(ArgumentError("version must be 0, 1, 2, or 3 (received $v)"))
    return ccall(
        (:cairo_pdf_surface_restrict_to_version, Cairo.libcairo), Nothing,
        (Ptr{UInt8}, Int32), surface.ptr, v
    )
end

# guard against some future changes silently making simple vector graphics be
# rasterized if they are using features unsupported by the SVG spec
function svg_isnt_rasterized(x)
    return mktempdir() do path
        path = joinpath(path, "test.svg")
        save(path, x)
        # this is rough but an easy way to catch rasterization,
        # if an image element is present in the svg
        return !occursin("<image id=", read(path, String))
    end
end

@testset "SVG rasterization" begin
    @test svg_isnt_rasterized(Scene())
    @test svg_isnt_rasterized(
        begin
            f = Figure(); Axis(f[1, 1]); f
        end
    )
    @test svg_isnt_rasterized(
        begin
            f = Figure(); Axis3(f[1, 1]); f
        end
    )
    @test svg_isnt_rasterized(
        begin
            f = Figure(); PolarAxis(f[1, 1]); f
        end
    )
    @test svg_isnt_rasterized(scatter(1:3))
    @test svg_isnt_rasterized(lines(1:3))
    @test svg_isnt_rasterized(arrows2d(Point(0, 0), Point(1, 1), taillength = 8))
    @test svg_isnt_rasterized(heatmap(rand(5, 5)))
    @test !svg_isnt_rasterized(image(rand(5, 5)))
    # issue 2510
    @test svg_isnt_rasterized(
        begin
            fig = Figure()
            ax = Axis(fig[1, 1])
            poly!(ax, Makie.GeometryBasics.Polygon(Point2.([[0, 0], [1, 0], [0, 1], [0, 0]])), color = ("#FF0000", 0.7), label = "foo")
            poly!(ax, Makie.GeometryBasics.Polygon(Point2.([[0, 0], [1, 0], [0, 1], [0, 0]])), color = (:blue, 0.7), label = "bar")
            fig[1, 2] = Legend(fig, ax, "Bar")
            fig
        end
    )
    @test svg_isnt_rasterized(poly(Circle(Point2f(0, 0), 10)))
    @test svg_isnt_rasterized(
        poly(
            BezierPath(
                [
                    MoveTo(0.0, 0.0), LineTo(1.0, 0.0), LineTo(1.0, 1.0), CurveTo(1.0, 1.0, 0.5, 1.0, 0.5, 0.5), ClosePath(),
                ]
            )
        )
    )
    @test !svg_isnt_rasterized(poly(rand(Point2f, 10); color = rand(RGBAf, 10)))

    poly1 = Makie.GeometryBasics.Polygon(rand(Point2f, 10))
    @test svg_isnt_rasterized(poly(Makie.GeometryBasics.MultiPolygon([poly1, poly1])))
    @test svg_isnt_rasterized(poly(Makie.GeometryBasics.MultiPolygon([poly1, poly1]), color = :red))
    @test svg_isnt_rasterized(poly(Makie.GeometryBasics.MultiPolygon([poly1, poly1]), color = [:red, :blue]))
end

struct PolyWrapper
    poly::Any
end
function Makie.convert_arguments(::Type{<:Poly}, poly::PolyWrapper)
    return convert_arguments(Poly, poly.poly)
end
struct MultiPolyWrapper
    poly::Vector
end
function Makie.convert_arguments(::Type{<:Poly}, poly::MultiPolyWrapper)
    return convert_arguments(Poly, poly.poly)
end

@testset "Polygon Wrappers" begin
    poly1 = Makie.GeometryBasics.Polygon(rand(Point2f, 10))
    poly2 = PolyWrapper(poly1)
    @test svg_isnt_rasterized(poly(poly2))
    @test svg_isnt_rasterized(poly(poly2; color = :red))
    @test svg_isnt_rasterized(poly(MultiPolyWrapper([poly1, poly1]); color = [:red, :blue]))
end

@testset "reproducible svg ids" begin
    # https://github.com/MakieOrg/Makie.jl/issues/2406
    f, ax, sc = scatter(1:10)
    save("test1.svg", f)
    save("test2.svg", f)
    @test read("test1.svg") == read("test2.svg")
    rm("test1.svg")
    rm("test2.svg")
end

# guard against some future changes silently making simple vector graphics be
# rasterized if they are using features unsupported by the SVG spec
function svg_has_image(x)
    return mktempdir() do path
        path = joinpath(path, "test.svg")
        save(path, x)
        # this is rough but an easy way to catch rasterization,
        # if an image element is present in the svg
        return occursin("<image id=", read(path, String))
    end
end

@testset "Internal rasterization" begin
    fig = Figure()
    ax = Axis(fig[1, 1])
    lp = lines!(ax, vcat(1:10, 10:-1:1))
    pts = Makie.GeometryBasics.Point2f[(0, 0), (1, 0), (0, 1)]
    pl = poly!(ax, Makie.GeometryBasics.Polygon(pts))

    @testset "Unrasterized SVG" begin
        @test !svg_has_image(fig)
    end

    @testset "Rasterized SVG" begin
        lp.rasterize = true
        @test svg_has_image(fig)
        lp.rasterize = 10
        @test svg_has_image(fig)
    end

end

#########################################
# Backend interface to Makie #
#########################################

"""
    tryrun(cmd::Cmd)
Try to run a command. Return `true` if `cmd` runs and is successful (exits with a code of `0`).
Return `false` otherwise.
"""
function tryrun(cmd::Cmd)
    try
        return success(cmd)
    catch e
        return false
    end
end

function openurl(url::String)
    if Sys.isapple()
        tryrun(`open $url`) && return
    elseif Sys.iswindows()
        tryrun(`powershell.exe start $url`) && return
    elseif Sys.isunix()
        tryrun(`xdg-open $url`) && return
        tryrun(`gnome-open $url`) && return
    end
    tryrun(`python -mwebbrowser $(url)`) && return
    # our last hope
    tryrun(`python3 -mwebbrowser $(url)`) && return
    return @warn("Can't find a way to open a browser, open $(url) manually!")
end

function Base.display(screen::Screen, scene::Scene; connect = false, figure = nothing)
    # Nothing to do, since drawing is done in the other functions
    # TODO write to file and implement upenurl
    return screen
end

function Base.display(screen::Screen{IMAGE}, scene::Scene; connect = false, figure = nothing, screen_config...)
    config = Makie.merge_screen_config(ScreenConfig, Dict{Symbol, Any}(screen_config))
    screen = Makie.apply_screen_config!(screen, config, scene)
    path = joinpath(mktempdir(), "display.png")
    Makie.push_screen!(scene, screen)
    cairo_draw(screen, scene)
    Cairo.write_to_png(screen.surface, path)
    if screen.visible
        openurl("file:///" * path)
    end
    return screen
end

function Makie.backend_show(screen::Screen{SVG}, io::IO, ::MIME"image/svg+xml", scene::Scene, figure = nothing)
    mark(io)
    # fix for #4970, to avoid that the finalizer of this surface tries to write to `io` later
    # when `io` is possibly not valid anymore
    Cairo.finish(screen.surface)
    # we can't avoid that Cairo writes an svg scaffold into `io` unless
    # we refactor the whole screen setup code so the svg surface isn't initialized with the `io`
    # in the first place, so instead we just overwrite that part again with the string we build below
    reset(io)

    Makie.push_screen!(scene, screen)
    # Display the plot on a new screen writing to a string, so that we can manipulate the
    # result (the io in `screen` should directly write to the file we're saving)
    svg = sprint() do io2
        screen2 = Screen(screen, io2, SVG)
        cairo_draw(screen2, scene)
        Cairo.flush(screen2.surface)
        Cairo.finish(screen2.surface)
    end

    # for some reason, in the svg, surfaceXXX ids keep counting up,
    # even with the very same figure drawn again and again
    # so we need to reset them to counting up from 1
    # so that the same figure results in the same svg and in the same salt
    surfaceids = sort(unique(collect(m.match for m in eachmatch(r"surface\d+", svg))))

    for (i, id) in enumerate(surfaceids)
        svg = replace(svg, id => "surface$i")
    end

    # salt svg ids with the 8 hex characters of the crc32 checksum to avoid collisions
    # across svgs when embedding them on websites.
    # the hash and therefore the salt will always be the same for the same file
    # so the output is deterministic
    salt = repr(CRC32c.crc32c(svg))[(end - 7):end]

    # matches:
    # id="someid"
    # xlink:href="someid" (but not xlink:href="data:someothercontent" which is how image data is attached)
    # url(#someid)
    svg = replace(svg, r"((?:(?:id|xlink:href)=\"(?!data:)[^\"]+)|url\(#[^)]+)" => SubstitutionString("\\1-$salt"))

    print(io, svg)
    return screen
end

function Makie.backend_show(screen::Screen{PDF}, io::IO, ::MIME"application/pdf", scene::Scene, figure = nothing)
    Makie.push_screen!(scene, screen)
    cairo_draw(screen, scene)
    Cairo.finish(screen.surface)
    return screen
end

function Makie.backend_show(screen::Screen{EPS}, io::IO, ::MIME"application/postscript", scene::Scene, figure = nothing)
    Makie.push_screen!(scene, screen)
    cairo_draw(screen, scene)
    Cairo.finish(screen.surface)
    return screen
end

# Disabling mimes and showable

const DISABLED_MIMES = Set{String}()
const SUPPORTED_MIMES = Set(
    [
        map(x -> string(x()), Makie.WEB_MIMES)...,
        "image/svg+xml",
        "application/pdf",
        "application/postscript",
        "image/png",
    ]
)

function Makie.backend_showable(::Type{Screen}, ::MIME{SYM}) where {SYM}
    supported_mimes = Base.setdiff(SUPPORTED_MIMES, DISABLED_MIMES)
    return string(SYM) in supported_mimes
end

"""
    to_mime_string(mime::Union{String, Symbol, MIME})

Converts anything like `"png", :png, "image/png", MIME"image/png"()` to `"image/png"`.
"""
function to_mime_string(mime::Union{String, Symbol, MIME})
    if mime isa MIME
        mime_str = string(mime)
        if !(mime_str in SUPPORTED_MIMES)
            error("Mime $(mime) not supported by CairoMakie")
        end
        return mime_str
    else
        mime_str = string(mime)
        if !(mime_str in SUPPORTED_MIMES)
            mime_str = string(to_mime(convert(RenderType, mime_str)))
        end
        return mime_str
    end
end

"""
    disable_mime!(mime::Union{String, Symbol, MIME}...)

The default is automatic, which lets the display system figure out the best mime.
If set to any other valid mime, will result in `showable(any_other_mime, figurelike)` to return false and only return true for `showable(preferred_mime, figurelike)`.
Depending on the display system used, this may result in nothing getting displayed.
"""
function disable_mime!(mimes::Union{String, Symbol, MIME}...)
    empty!(DISABLED_MIMES) # always start from 0
    if isempty(mimes)
        # Reset disabled mimes when called with no arguments
        return
    end
    mime_strings = Set{String}()
    for mime in mimes
        push!(mime_strings, to_mime_string(mime))
    end
    union!(DISABLED_MIMES, mime_strings)
    return
end

function enable_only_mime!(mimes::Union{String, Symbol, MIME}...)
    empty!(DISABLED_MIMES) # always start from 0
    if isempty(mimes)
        # Reset disabled mimes when called with no arguments
        return
    end
    mime_strings = Set{String}()
    for mime in mimes
        push!(mime_strings, to_mime_string(mime))
    end
    union!(DISABLED_MIMES, setdiff(SUPPORTED_MIMES, mime_strings))
    return
end

################################################################################
#                    Poly - the not so primitive, primitive                    #
################################################################################

deref(x) = x
deref(x::Base.RefValue) = x[]

"""
Special method for polys so we don't fall back to atomic meshes, which are much more
complex and slower to draw than standard paths with single color.
"""
function draw_plot(scene::Scene, screen::Screen, poly::Poly)
    # dispatch on input arguments to poly to use smarter drawing methods than
    # meshes if possible.
    # however, since recipes exist, we can't explicitly handle all cases here
    # so, we should also take a look at converted
    # First, we check whether a `draw_poly` method exists for the input arguments
    # before conversion:
    if Base.hasmethod(draw_poly, Tuple{Scene, Screen, typeof(poly), typeof.(deref(poly.args[]))...})
        return draw_poly(scene, screen, poly, deref(poly.args[])...)
        # If not, we check whether a `draw_poly` method exists for the arguments after conversion
        # (`plot.converted`).  This allows anything which decomposes to be checked for.
    elseif Base.hasmethod(draw_poly, Tuple{Scene, Screen, typeof(poly), typeof.(deref(poly.converted[]))...})
        return draw_poly(scene, screen, poly, deref(poly.converted[])...)
        # In the worst case, we return to drawing the polygon as a mesh + lines.
    else
        return draw_poly_as_mesh(scene, screen, poly)
    end
end

# Override `is_cairomakie_atomic_plot` to allow `poly` to remain a unit,
# instead of auto-decomposing in lines and mesh.
is_cairomakie_atomic_plot(plot::Poly) = true


function draw_poly_as_mesh(scene, screen, poly)
    for i in eachindex(poly.plots)
        draw_plot(scene, screen, poly.plots[i])
    end
    return
end

########################################
### outline methods (::Vector{<:VecTypes{2}})
########################################

function draw_poly(scene::Scene, screen::Screen, poly, points::Vector{<:Point2})
    color = to_cairo_color(poly.color[], poly)
    strokecolor = to_cairo_color(poly.strokecolor[], poly)
    strokestyle = Makie.convert_attribute(poly.linestyle[], key"linestyle"())

    miter_limit = to_cairo_miter_limit(poly.miter_limit[])
    joinstyle = to_cairo_joinstyle(poly.joinstyle[])
    linecap = to_cairo_linecap(poly.linecap[])

    draw_poly(
        scene, screen, poly, points, color,
        poly.model[], strokecolor, strokestyle, poly.strokewidth[], miter_limit, joinstyle, linecap
    )
    if color isa Cairo.CairoPattern
        pattern_set_matrix(color, Cairo.CairoMatrix(1, 0, 0, 1, 0, 0))
    end
    return
end

function draw_poly(scene::Scene, screen::Screen, poly, points_list::Vector{<:Vector{<:Point2}})
    color = to_cairo_color(poly.color[], poly)
    strokecolor = to_cairo_color(poly.strokecolor[], poly)
    strokestyle = Makie.convert_attribute(poly.linestyle[], key"linestyle"())

    miter_limit = to_cairo_miter_limit(poly.miter_limit[])
    joinstyle = to_cairo_joinstyle(poly.joinstyle[])
    linecap = to_cairo_linecap(poly.linecap[])

    broadcast_foreach(
        points_list, color,
        strokecolor, strokestyle, poly.strokewidth[], Ref(poly.model[])
    ) do points, color, strokecolor, strokestyle, strokewidth, model
        draw_poly(scene, screen, poly, points, color, model, strokecolor, strokestyle, strokewidth, miter_limit, joinstyle, linecap)
    end
    if color isa Cairo.CairoPattern
        pattern_set_matrix(color, Cairo.CairoMatrix(1, 0, 0, 1, 0, 0))
    end
    return
end

draw_poly(scene::Scene, screen::Screen, poly, circle::Circle) = draw_poly(scene, screen, poly, decompose(Point2f, circle))

# when color is a Makie.AbstractPattern, we don't need to go to Mesh
function draw_poly(
        scene::Scene, screen::Screen, poly, points::Vector{<:Point2}, color::Union{Colorant, Cairo.CairoPattern},
        model, strokecolor, strokestyle, strokewidth, miter_limit, joinstyle, linecap
    )
    space = poly.space[]
    points = apply_transform(transform_func(poly), points)
    points = clip_poly(poly.clip_planes[], points, space, model)
    points = _project_position(scene, space, points, model, true)

    Cairo.move_to(screen.context, points[1]...)
    for p in points[2:end]
        Cairo.line_to(screen.context, p...)
    end
    Cairo.close_path(screen.context)

    set_source(screen.context, color)

    Cairo.fill_preserve(screen.context)
    Cairo.set_source_rgba(screen.context, rgbatuple(to_color(strokecolor))...)
    Cairo.set_line_width(screen.context, strokewidth)
    set_miter_limit(screen.context, miter_limit)
    Cairo.set_line_join(screen.context, joinstyle)
    Cairo.set_line_cap(screen.context, linecap)

    pattern = to_cairo_linestyle(strokestyle, strokewidth)
    if !isnothing(pattern)
        Cairo.set_dash(screen.context, pattern)
    end
    Cairo.stroke(screen.context)
    return
end

# As a general fallback, draw all polys as meshes.
# This also applies for e.g. per-vertex color.
function draw_poly(
        scene::Scene, screen::Screen, poly, points, color,
        model, strokecolor, strokestyle, strokewidth, miter_limit, joinstyle, linecap
    )
    return draw_poly_as_mesh(scene, screen, poly)
end

########################################
### GeometryPrimtive and BezierPath methods
########################################

draw_poly(scene::Scene, screen::Screen, poly, rect::Rect2) = draw_poly(scene, screen, poly, [rect])
draw_poly(scene::Scene, screen::Screen, poly, bezierpath::BezierPath) = draw_poly(scene, screen, poly, [bezierpath])

function draw_poly(scene::Scene, screen::Screen, poly, shapes::Vector{<:Union{Rect2, BezierPath}})
    model = poly.model[]::Mat4d
    space = poly.space[]::Symbol
    planes = poly.clip_planes[]::Vector{Plane3f}

    projected_shapes = map(shapes) do shape
        clipped = clip_shape(planes, shape, space, model)
        return project_shape(poly, space, clipped, model)
    end

    color = to_cairo_color(poly.color[], poly)

    linestyle = Makie.convert_attribute(poly.linestyle[], key"linestyle"())
    if isnothing(linestyle)
        linestyle_diffed = nothing
    elseif linestyle isa AbstractVector{<:Real}
        linestyle_diffed = diff(Float64.(linestyle))
    else
        error("Wrong type for linestyle: $(poly.linestyle[]).")
    end
    strokecolor = to_cairo_color(poly.strokecolor[], poly)

    miter_limit = to_cairo_miter_limit(poly.miter_limit[])
    joinstyle = to_cairo_joinstyle(poly.joinstyle[])
    linecap = to_cairo_linecap(poly.linecap[])

    broadcast_foreach(projected_shapes, color, strokecolor, poly.strokewidth[]) do shape, c, sc, sw
        create_shape_path!(screen.context, shape)
        set_source(screen.context, c)
        Cairo.fill_preserve(screen.context)
        pattern = to_cairo_linestyle(linestyle, sw)
        if !isnothing(pattern)
            Cairo.set_dash(screen.context, pattern)
        end
        set_source(screen.context, sc)
        Cairo.set_line_width(screen.context, sw)
        set_miter_limit(screen.context, miter_limit)
        Cairo.set_line_join(screen.context, joinstyle)
        Cairo.set_line_cap(screen.context, linecap)
        Cairo.stroke(screen.context)
    end
    if color isa Cairo.CairoPattern
        pattern_set_matrix(color, Cairo.CairoMatrix(1, 0, 0, 1, 0, 0))
    end
    return
end

function project_shape(scene, space, shape::BezierPath, model)
    commands = Makie.PathCommand[]
    for cmd in shape.commands
        if cmd isa EllipticalArc
            bezier = Makie.elliptical_arc_to_beziers(cmd)
            for b in bezier.commands
                push!(commands, project_command(b, scene, space, model))
            end
        else
            push!(commands, project_command(cmd, scene, space, model))
        end
    end
    return BezierPath(commands)
end

function create_shape_path!(ctx, r::Rect2)
    return Cairo.rectangle(ctx, origin(r)..., widths(r)...)
end

function create_shape_path!(ctx, b::BezierPath)
    isempty(b.commands) && return
    if !isa(first(b.commands), MoveTo)
        error("The first command in a BezierPath must be `MoveTo`, but is $(first(b.commands)).")
    end

    for cmd in b.commands
        path_command(ctx, cmd)
    end

    # match W/GLMakie
    if !isa(last(b.commands), ClosePath)
        Cairo.close_path(ctx)
    end
    return
end

function polypath(ctx, polygon)
    isempty(polygon) && return nothing
    ext = decompose(Point2f, polygon.exterior)
    Cairo.set_fill_type(ctx, Cairo.CAIRO_FILL_RULE_EVEN_ODD)
    Cairo.move_to(ctx, ext[1]...)
    for point in ext[2:end]
        Cairo.line_to(ctx, point...)
    end
    Cairo.close_path(ctx)
    interiors = decompose.(Point2f, polygon.interiors)
    for interior in interiors
        # Cairo needs to have interiors counter clockwise
        n = length(interior)
        Cairo.move_to(ctx, interior[1]...)
        for idx in 2:n
            point = interior[idx]
            Cairo.line_to(ctx, point...)
        end
        Cairo.close_path(ctx)
    end
    return
end

draw_poly(scene::Scene, screen::Screen, poly, polygon::Polygon) = draw_poly(scene, screen, poly, [polygon])
draw_poly(scene::Scene, screen::Screen, poly, multipolygon::MultiPolygon) = draw_poly(scene, screen, poly, multipolygon.polygons)

function draw_poly(scene::Scene, screen::Screen, poly, polygons::AbstractArray{<:Polygon})
    model = poly.model[]
    space = poly.space[]
    projected_polys = map(polygons) do polygon
        return project_polygon(poly, space, polygon, poly.clip_planes[], model)
    end

    color = to_cairo_color(poly.color[], poly)
    strokecolor = to_cairo_color(poly.strokecolor[], poly)
    strokestyle = Makie.convert_attribute(poly.linestyle[], key"linestyle"())

    miter_limit = to_cairo_miter_limit(poly.miter_limit[])
    joinstyle = to_cairo_joinstyle(poly.joinstyle[])
    linecap = to_cairo_linecap(poly.linecap[])

    broadcast_foreach(projected_polys, color, strokecolor, poly.strokewidth[]) do po, c, sc, sw
        polypath(screen.context, po)
        set_source(screen.context, c)
        Cairo.fill_preserve(screen.context)
        set_source(screen.context, sc)
        Cairo.set_line_width(screen.context, sw)
        pattern = to_cairo_linestyle(strokestyle, sw)
        if !isnothing(pattern)
            Cairo.set_dash(screen.context, pattern)
        end
        set_miter_limit(screen.context, miter_limit)
        Cairo.set_line_join(screen.context, joinstyle)
        Cairo.set_line_cap(screen.context, linecap)
        Cairo.stroke(screen.context)
    end

    if color isa Cairo.CairoPattern
        pattern_set_matrix(color, Cairo.CairoMatrix(1, 0, 0, 1, 0, 0))
    end
    return
end

function draw_poly(scene::Scene, screen::Screen, poly, polygons::AbstractArray{<:MultiPolygon})
    model = poly.model[]
    space = poly.space[]
    projected_polys = map(polygons) do polygon
        project_multipolygon(poly, space, polygon, poly.clip_planes[], model)
    end

    color = to_cairo_color(poly.color[], poly)
    strokecolor = to_cairo_color(poly.strokecolor[], poly)
    strokestyle = Makie.convert_attribute(poly.linestyle[], key"linestyle"())

    miter_limit = to_cairo_miter_limit(poly.miter_limit[])
    joinstyle = to_cairo_joinstyle(poly.joinstyle[])
    linecap = to_cairo_linecap(poly.linecap[])
    broadcast_foreach(projected_polys, color, strokecolor, poly.strokewidth[]) do mpo, c, sc, sw
        for po in mpo.polygons
            polypath(screen.context, po)
            set_source(screen.context, c)
            Cairo.fill_preserve(screen.context)
            set_source(screen.context, sc)
            Cairo.set_line_width(screen.context, sw)
            pattern = to_cairo_linestyle(strokestyle, sw)
            if !isnothing(pattern)
                Cairo.set_dash(screen.context, pattern)
            end
            set_miter_limit(screen.context, miter_limit)
            Cairo.set_line_join(screen.context, joinstyle)
            Cairo.set_line_cap(screen.context, linecap)
            Cairo.stroke(screen.context)
        end
    end

    if color isa Cairo.CairoPattern
        pattern_set_matrix(color, Cairo.CairoMatrix(1, 0, 0, 1, 0, 0))
    end
    return
end


################################################################################
#                                     Band                                     #
#     Override because band is usually a polygon, but because it supports      #
#        gradients as well via `mesh` we have to intercept the poly use        #
################################################################################

function band_segment_ranges(lowerpoints, upperpoints)
    ranges = UnitRange{Int}[]
    start = nothing

    for i in eachindex(lowerpoints, upperpoints)
        if isnan(lowerpoints[i]) || isnan(upperpoints[i])
            if start !== nothing && i - start > 1 # more than one point
                push!(ranges, start:(i - 1))
            end
            start = nothing
        elseif start === nothing
            start = i
        elseif i == lastindex(lowerpoints)
            push!(ranges, start:i)
        end
    end
    return ranges
end

# we can draw an array-colored band using a linear gradient if it's a "normal" band
# in which all upper/lower values with the same index are at the same x value.
# the linear gradient will look much better than falling back to mesh drawing, which
# results in many little triangles when colors are semitransparent and a jagged corner
function is_linear_gradient_compatible(band)
    return all(zip(band[1][], band[2][])) do (p1, p2)
        p1 isa Point2 && p2 isa Point2 && p1[1] == p2[1]
    end
end

function draw_plot(
        scene::Scene, screen::Screen,
        band::Band{<:Tuple{<:AbstractVector{<:Point2}, <:AbstractVector{<:Point2}}}
    )
    if is_linear_gradient_compatible(band) || !(band.color[] isa AbstractArray)
        color = to_cairo_color(band.color[], band)

        model = band.model[]
        space = band.space[]

        xdir::Bool = band.direction[] === :x

        upperpoints = xdir ? band[1][] : reverse.(band[1][])
        lowerpoints = xdir ? band[2][] : reverse.(band[2][])

        for rng in band_segment_ranges(lowerpoints, upperpoints)
            points_segment = vcat(@view(lowerpoints[rng]), reverse(@view(upperpoints[rng])))
            points = clip_poly(band.clip_planes[], points_segment, space, model)
            points = project_position.(Ref(band), space, points, Ref(model))
            Cairo.move_to(screen.context, points[1]...)
            for p in points[2:end]
                Cairo.line_to(screen.context, p...)
            end
            Cairo.close_path(screen.context)
            if color isa AbstractVector
                # for the gradient we use all points, irrespective of clipping
                lower_proj = project_position.(Ref(band), space, points_segment[1:(end ÷ 2)], Ref(model))
                p_first = lower_proj[begin]
                p_last = lower_proj[end]
                P = typeof(p_last)
                # the gradient must be parallel to x or y axis
                p_last = xdir ? P(p_last[1], p_first[2]) : P(p_first[1], p_last[2])
                dist = p_last - p_first
                pat = Cairo.pattern_create_linear(p_first..., p_last...)
                for (p, c) in zip(lower_proj, color)
                    i = xdir ? 1 : 2
                    fraction = (p[i] - p_first[i]) / dist[i]
                    Cairo.pattern_add_color_stop_rgba(pat, fraction, red(c), green(c), blue(c), alpha(c))
                end
                Cairo.set_source(screen.context, pat)
                Cairo.fill(screen.context)
                Cairo.destroy(pat)
            else
                set_source(screen.context, color)
                Cairo.fill(screen.context)
            end
        end

        if color isa Cairo.CairoPattern
            pattern_set_matrix(color, Cairo.CairoMatrix(1, 0, 0, 1, 0, 0))
        end

        for p in band.plots
            p isa Mesh && continue
            draw_plot(scene, screen, p)
        end
    else
        for p in band.plots
            draw_plot(scene, screen, p)
        end
    end

    return nothing
end

# Override `is_cairomakie_atomic_plot` to allow this dispatch of `band` to remain a unit,
# instead of auto-decomposing in lines and mesh.
function is_cairomakie_atomic_plot(plot::Band{<:Tuple{<:AbstractVector{<:Point2}, <:AbstractVector{<:Point2}}})
    return true
end

#################################################################################
#                                  Tricontourf                                  #
# Tricontourf creates many disjoint polygons that are adjacent and form contour #
#  bands, however, at the gaps we see white antialiasing artifacts. Therefore   #
#               we override behavior and draw each band in one go               #
#################################################################################

function draw_plot(scene::Scene, screen::Screen, tric::Tricontourf)

    pol = only(tric.plots)::Poly
    colornumbers = pol.color[]
    colors = to_cairo_color(colornumbers, pol)
    polygons = pol[1][]
    model = pol.model[]
    space = pol.space[]
    projected_polys = project_polygon.(Ref(tric), space, polygons, Ref(tric.clip_planes[]), Ref(model))

    function draw_tripolys(polys, colornumbers, colors)
        for (i, (pol, colnum, col)) in enumerate(zip(polys, colornumbers, colors))
            polypath(screen.context, pol)
            if i == length(colornumbers) || colnum != colornumbers[i + 1]
                set_source(screen.context, col)
                Cairo.fill(screen.context)
            end
        end
        return
    end

    draw_tripolys(projected_polys, colornumbers, colors)

    if colors isa Cairo.CairoPattern
        pattern_set_matrix(colors, Cairo.CairoMatrix(1, 0, 0, 1, 0, 0))
    end

    return
end

# Override `is_cairomakie_atomic_plot` to allow `Tricontourf` to remain a unit,
# instead of auto-decomposing in lines and mesh.
function is_cairomakie_atomic_plot(plot::Tricontourf)
    return true
end


################################################################################
#                                   Arrows2D                                   #
#   The SVG backend does not support CairoMeshPattern, rasterizing the image   #
#  instead of using vector constructs.  Avoid a simple arrow rasterizing the   #
#  image by intercepting simple (typical) arrows and redirecting them through  #
#             the already special cased 2D polygon rendering path.             #
################################################################################

function draw_plot(scene::Scene, screen::Screen, arrow::Arrows2D)
    poly = only(arrow.plots)
    color = to_cairo_color(poly.color[], poly)
    model = Ref(poly.model[])
    strokecolor = to_cairo_color(poly.strokecolor[], poly)
    strokestyle = Makie.convert_attribute(poly.linestyle[], key"linestyle"())
    strokewidth = poly.strokewidth[]

    miter_limit = to_cairo_miter_limit(poly.miter_limit[])
    joinstyle = to_cairo_joinstyle(poly.joinstyle[])
    linecap = to_cairo_linecap(poly.linecap[])

    broadcast_foreach(
        poly.meshes[], color, model, strokecolor, strokestyle, strokewidth
    ) do mesh, props...
        points = [Point2(c[1], c[2]) for c in coordinates(mesh)]
        draw_poly(scene, screen, poly, points, props..., miter_limit, joinstyle, linecap)
    end
    return nothing
end

function is_cairomakie_atomic_plot(plot::Arrows2D)
    return true
end

using PrecompileTools

macro compile(block)
    return quote
        figlike = $(esc(block))
        Makie.colorbuffer(figlike)
    end
end

let
    @compile_workload begin
        CairoMakie.activate!()
        include(Makie.SHARED_PRECOMPILE_PATH)
        # Cleanup globals to avoid serializing stale state (fonts, figures, tasks)
        # Note: __init__ doesn't run during precompilation, so we must always clean up here
        Makie.cleanup_globals()
    end
end
precompile(openurl, (String,))
precompile(
    draw_atomic_scatter, (
        Scene, Cairo.CairoContext, Tuple{typeof(identity), typeof(identity)},
        Vector{ColorTypes.RGBA{Float32}}, Vec{2, Float32}, ColorTypes.RGBA{Float32},
        Float32, BezierPath, Vec{3, Float32}, Quaternionf,
        Mat4f, Vector{Point{2, Float32}},
        Mat4f, Makie.FreeTypeAbstraction.FTFont, Symbol,
        Symbol, Vector{Plane3f}, Bool,
    )
)
